using System.Collections.Generic;

using BizHawk.Emulation.Cores;

using static BizHawk.Tests.Testroms.GB.GBHelper;

namespace BizHawk.Tests.Testroms.GB.GambatteSuite
{
	public sealed partial class GambatteSuite
	{
		public readonly struct GambatteHexStrTestCase
		{
			public static readonly GambatteHexStrTestCase Dummy = new("missing_files", new(CoreNames.Gambatte, ConsoleVariant.DMG), string.Empty, string.Empty);

			public static readonly IReadOnlyList<string> KnownFailures = new[]
			{
				"cgbpal_m3.cgbpal_m3end_1_cgb04c_out7 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_3_cgb04c_out0 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_ds_1_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3end_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3end_ds_3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3end_scx2_1_cgb04c_out7 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx2_3_cgb04c_out0 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx5_1_cgb04c_out7 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx5_3_cgb04c_out0 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_1_cgb04c_out7 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_1_cgb04c_out7 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_1_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_3_cgb04c_out0 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_3_cgb04c_out0 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_m3end_scx5_ds_3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_m3start_ds_1_cgb04c_out1 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_m3start_ds_1_cgb04c_out1 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_m3start_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_read_m3start_2_cgb04c_outFF on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_read_m3start_2_cgb04c_outFF on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_read_m3start_ds_1_cgb04c_out00 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_read_m3start_ds_lcdoffset1_2_cgb04c_outFF on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_read_m3start_ds_lcdoffset1_2_cgb04c_outFF on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_read_m3start_lcdoffset1_1_cgb04c_out00 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_read_m3start_lcdoffset1_1_cgb04c_out00 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_read_m3start_lcdoffset1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_write_m3start_2_cgb04c_out00 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_write_m3start_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_write_m3start_ds_1_cgb04c_out01 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_write_m3start_ds_lcdoffset1_2_cgb04c_out00 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_write_m3start_ds_lcdoffset1_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"cgbpal_m3.cgbpal_write_m3start_lcdoffset1_1_cgb04c_out01 on CGB_C in GBHawk",
				"cgbpal_m3.cgbpal_write_m3start_lcdoffset1_1_cgb04c_out01 on CGB_C in SameBoy",
				"cgbpal_m3.cgbpal_write_m3start_lcdoffset1_1_cgb04c_out01 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.ly_dmg08_out00_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.ly_dmg08_out00_cgb04c_out90 on DMG in SameBoy (no BIOS)",
				"display_startstate.stat_1_cgb04c_out87 on CGB_C in SameBoy",
				"display_startstate.stat_1_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_1_dmg08_out85 on DMG in SameBoy (no BIOS)",
				"display_startstate.stat_2_cgb04c_out84 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_2_dmg08_out84 on DMG in SameBoy (no BIOS)",
				"display_startstate.stat_scx2_1_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_scx2_2_cgb04c_out84 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_scx3_1_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_scx3_2_cgb04c_out84 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_scx5_1_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"display_startstate.stat_scx5_2_cgb04c_out84 on CGB_C in SameBoy (no BIOS)",
				"div.start_inc_1_cgb04c_out1E on CGB_C in SameBoy (no BIOS)",
				"div.start_inc_1_dmg08_outAB on DMG in SameBoy (no BIOS)",
				"div.start_inc_2_cgb04c_out1F on CGB_C in SameBoy (no BIOS)",
				"div.start_inc_2_dmg08_outAC on DMG in SameBoy (no BIOS)",
				"dma.dma_dst_wrap_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.dma_dst_wrap_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.dma_hiram_read_result_cgb04c_out1 on CGB_C in SameBoy",
				"dma.dma_hiram_read_result_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.dma_vram_read_cgb04c_out7 on CGB_C in SameBoy",
				"dma.dma_vram_read_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_2xshort_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_2xshort_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_2xshort_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_2xshort_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_long_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.gdma_cycles_long_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_long_scx3_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.gdma_cycles_long_scx3_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_long_scx5_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.gdma_cycles_long_scx5_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_long_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_long_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_short_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_short_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_short_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_short_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_cycles_short_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_cycles_short_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.gdma_weird_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.gdma_weird_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_cycles_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_cycles_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_cycles_scx3_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_cycles_scx3_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_cycles_scx5_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_cycles_scx5_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_cycles_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"dma.hdma_cycles_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_disable_display_1_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_disable_display_1_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_ei_m3halt_m0unhalt_ly_2_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_ei_m3halt_m0unhalt_ly_2_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_destl_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_destl_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_scx2_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_scx2_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_scx3_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_scx3_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_scx5_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_scx5_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_disable_scx5_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_disable_scx5_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_ei_m3halt_m2unhalt_ly_scx1_2_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_ei_m3halt_m2unhalt_ly_scx1_2_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_ei_m3halt_m2unhalt_ly_scx1_4_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_ei_m3halt_m2unhalt_ly_scx1_4_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_enable_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_late_enable_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_enable_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_late_enable_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_enable_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"dma.hdma_late_enable_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_late_enable_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_enable_lcdoffset3_1_cgb04c_out1 on CGB_C in GBHawk",
				"dma.hdma_late_enable_lcdoffset3_2_cgb04c_out0 on CGB_C in GBHawk",
				"dma.hdma_late_enable_lcdoffset3_2_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_late_enable_lcdoffset3_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_if_and_ie_halt_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_late_if_and_ie_halt_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_late_if_and_ie_halt_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_length_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_length_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0halt_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_late_m0halt_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m0halt_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0halt_ds_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_late_m0halt_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m0halt_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0halt_ds_lcdoffset1_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_late_m0halt_ds_lcdoffset1_2_cgb04c_outFF on CGB_C in SameBoy",
				"dma.hdma_late_m0halt_ds_lcdoffset1_2_cgb04c_outFF on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0halt_lcdoffset3_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_late_m0halt_lcdoffset3_2_cgb04c_outFF on CGB_C in SameBoy",
				"dma.hdma_late_m0halt_lcdoffset3_2_cgb04c_outFF on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0unhalt_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m0unhalt_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m0unhalt_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m0unhalt_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx1_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx1_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx1_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx2_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx2_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_inc_scx2_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx1_2_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx1_2_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx1_4_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx1_4_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx2_2_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx2_2_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx2_4_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_ly_scx2_4_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3halt_m2unhalt_scx1_2_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_late_m3halt_m2unhalt_scx2_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3halt_m2unhalt_scx2_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx1_2_cgb04c_out80 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_hdma5_scx1_2_cgb04c_out80 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx1_2_cgb04c_out80 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx1_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx1_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx1_ds_2_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_hdma5_scx2_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx2_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx2_2_cgb04c_out80 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_hdma5_scx2_2_cgb04c_out80 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx2_2_cgb04c_out80 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_hdma5_scx2_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_hdma5_scx2_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_inc_scx1_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_inc_scx1_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_inc_scx1_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_ly_scx1_2_cgb04c_out93 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_ly_scx1_2_cgb04c_out93 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_ly_scx1_4_cgb04c_out93 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_ly_scx1_4_cgb04c_out93 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_ly_scx1_4_cgb04c_out93 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_ly_scx1_6_cgb04c_out93 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_ly_scx1_6_cgb04c_out93 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_2_cgb04c_out9F on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx1_ds_2_cgb04c_out9F on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx2_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx2_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx2_ds_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_read_hdmadst00_scx2_ds_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_3_cgb04c_outF6 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_3_cgb04c_outF6 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_3_cgb04c_outF6 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_4_cgb04c_outF7 on CGB_C in GBHawk",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_4_cgb04c_outF7 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_4_cgb04c_outF7 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_5_cgb04c_outF8 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_5_cgb04c_outF8 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_6_cgb04c_outF9 on CGB_C in SameBoy",
				"dma.hdma_late_m3speedchange_tima_scx1_ds_6_cgb04c_outF9 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_speedchange_inc_scx1_ds_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_late_speedchange_inc_scx1_ds_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_late_speedchange_inc_scx1_ds_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_late_wrambank_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_late_wrambank_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m0halt_late_m3unhalt_scx1_2_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_m0halt_late_m3unhalt_scx1_2_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_m0halt_late_m3unhalt_scx1_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m0speedchange_late_m3wakeup_scx1_2_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_m0speedchange_late_m3wakeup_scx1_2_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_m0speedchange_late_m3wakeup_scx1_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m0speedchange_late_m3wakeup_scx2_1_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_m0speedchange_late_m3wakeup_scx2_2_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_m0speedchange_late_m3wakeup_scx2_2_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_m0speedchange_late_m3wakeup_scx2_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m3halt_m0unhalt_ly_2_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_m3halt_m0unhalt_ly_2_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m3halt_m1unhalt_hdma5_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_m3halt_m1unhalt_hdma5_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_m3speedchange_late_m0wakeup_2_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_m3speedchange_late_m0wakeup_2_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_pc_7ffe_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_pc_7ffe_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_ly0_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_ly0_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_scx2_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_scx2_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_scx3_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_scx3_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_scx5_1_cgb04c_out0 on CGB_C in SameBoy",
				"dma.hdma_start_scx5_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_scx5_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_scx5_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_start_scx5_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"dma.hdma_start_scx5_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_7fffhalt_inc_m3unhalt_cgb04c_out01 on CGB_C in GBHawk",
				"dma.hdma_transition_7fffhalt_inc_m3unhalt_cgb04c_out01 on CGB_C in SameBoy",
				"dma.hdma_transition_7fffhalt_inc_m3unhalt_cgb04c_out01 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_transition_ei_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_ei_halt_late_unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_ei_halt_late_unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_ei_halt_late_unhalt_scx1_2_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_transition_halt_hdmadst_unhalt_cgb04c_out01 on CGB_C in GBHawk",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_transition_halt_late_unhalt_ldaaimm_hdma_scx1_2_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_halt_late_unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_halt_late_unhalt_scx1_1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_halt_late_unhalt_scx1_2_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_transition_halt_m0unhalt_ldaaimm_scx1_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_transition_halt_m0unhalt_ldaaimm_scx1_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_transition_halt_m0unhalt_ldaaimm_scx1_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_oamdma_1_cgb04c_out509E529C on CGB_C in SameBoy",
				"dma.hdma_transition_oamdma_1_cgb04c_out509E529C on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_oamdma_2_cgb04c_out67 on CGB_C in SameBoy",
				"dma.hdma_transition_oamdma_2_cgb04c_out67 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_7fffstop_inc_cgb04c_out02 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_7fffstop_inc_cgb04c_out02 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_7fffstop_inc_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_hdmalen00_hdma5_scx1_cgb04c_out80 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_hdmalen00_hdma5_scx1_cgb04c_out80 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_hdmalen00_hdma5_scx1_cgb04c_out80 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_hdmalen01_hdma5_scx1_cgb04c_out81 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_hdmalen01_hdma5_scx1_cgb04c_out81 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_hdmalen01_hdma5_scx1_cgb04c_out81 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_hdmalen01_hdmadst10_scx1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_hdmalen01_hdmadst10_scx1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_hdmalen01_hdmadst10_scx1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_hdmalen7f_hdma5_scx1_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_hdmalen7f_hdmadst10_scx1_cgb04c_out00 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_hdmalen7f_hdmadst10_scx1_cgb04c_out00 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_hdmalen7f_hdmadst10_scx1_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_cgb04c_outFF on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_cgb04c_outFF on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_cgb04c_outFF on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_ds_cgb04c_out03 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_ds_cgb04c_out03 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_ldaaimm_scx1_ds_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"dma.hdma_transition_speedchange_oamdma_cgb04c_out71 on CGB_C in GBHawk",
				"dma.hdma_transition_speedchange_oamdma_cgb04c_out71 on CGB_C in SameBoy",
				"dma.hdma_transition_speedchange_oamdma_cgb04c_out71 on CGB_C in SameBoy (no BIOS)",
				"dma.late_gdma_pc_7ffe_1_cgb04c_out02 on CGB_C in SameBoy",
				"dma.late_gdma_pc_7ffe_1_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"enable_display.enable_display_ly0_m0irq_trigger_dmg08_cgb04c_out0 on DMG in GBHawk",
				"enable_display.enable_display_ly0_oambusy_read_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"enable_display.enable_display_ly0_oambusy_read_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"enable_display.enable_display_ly0_oambusy_read_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on DMG in SameBoy",
				"enable_display.enable_display_ly0_wemaster_1_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"enable_display.frame0_m0irq_count_scx2_1_dmg08_cgb04c_out90 on DMG in GBHawk",
				"enable_display.frame0_m0irq_count_scx3_1_dmg08_cgb04c_out90 on DMG in GBHawk",
				"enable_display.frame0_m2irq_count_1_dmg08_cgb04c_out98 on DMG in GBHawk",
				"enable_display.frame0_m2stat_count_1_dmg08_cgb04c_out91 on CGB_C in GBHawk",
				"enable_display.frame0_m2stat_count_ds_1_cgb04c_out91 on CGB_C in SameBoy",
				"enable_display.frame0_m2stat_count_ds_1_cgb04c_out91 on CGB_C in SameBoy (no BIOS)",
				"enable_display.frame1_ly_count_2_dmg08_cgb04c_out9A on CGB_C in GBHawk",
				"enable_display.frame1_m2irq_count_2_dmg08_cgb04c_out91 on DMG in GBHawk",
				"enable_display.frame1_m2stat_count_1_dmg08_cgb04c_out91 on CGB_C in GBHawk",
				"enable_display.frame1_m2stat_count_1_dmg08_cgb04c_out91 on CGB_C in SameBoy",
				"enable_display.frame1_m2stat_count_1_dmg08_cgb04c_out91 on CGB_C in SameBoy (no BIOS)",
				"enable_display.frame1_m2stat_count_ds_1_cgb04c_out91 on CGB_C in SameBoy",
				"enable_display.frame1_m2stat_count_ds_1_cgb04c_out91 on CGB_C in SameBoy (no BIOS)",
				"enable_display.ly0_late_cgbpr_1_cgb04c_out55 on CGB_C in GBHawk",
				"enable_display.ly0_late_cgbpr_ds_1_cgb04c_out55 on CGB_C in GBHawk",
				"enable_display.ly0_late_cgbpw_1_cgb04c_outAA on CGB_C in GBHawk",
				"enable_display.ly0_late_cgbpw_ds_1_cgb04c_outAA on CGB_C in GBHawk",
				"enable_display.ly0_late_oamw_ds_2_cgb04c_out55 on CGB_C in GBHawk",
				"enable_display.ly0_late_scx7_m3stat_scx0_2_dmg08_out87_cgb04c_out84 on DMG in GBHawk",
				"enable_display.ly0_late_scx7_m3stat_scx1_1_dmg08_cgb04c_out87 on CGB_C in GBHawk",
				"enable_display.ly0_late_scx7_m3stat_scx1_1_dmg08_cgb04c_out87 on CGB_C in SameBoy",
				"enable_display.ly0_late_scx7_m3stat_scx1_1_dmg08_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"enable_display.ly0_late_scx7_m3stat_scx1_1_dmg08_cgb04c_out87 on DMG in GBHawk",
				"enable_display.ly0_late_scx7_m3stat_scx3_1_dmg08_cgb04c_out87 on CGB_C in GBHawk",
				"enable_display.ly0_late_scx7_m3stat_scx3_1_dmg08_cgb04c_out87 on CGB_C in SameBoy",
				"enable_display.ly0_late_scx7_m3stat_scx3_1_dmg08_cgb04c_out87 on CGB_C in SameBoy (no BIOS)",
				"enable_display.ly0_late_scx7_m3stat_scx3_1_dmg08_cgb04c_out87 on DMG in GBHawk",
				"enable_display.ly0_late_vramr_2_dmg08_outFF_cgb04c_out55 on CGB_C in GBHawk",
				"enable_display.ly0_late_vramw_2_dmg08_out55_cgb04c_outAA on CGB_C in GBHawk",
				"enable_display.ly0_m0irq_scx0_1_dmg08_cgb04c_outE0 on DMG in GBHawk",
				"enable_display.ly0_m0irq_scx1_1_dmg08_cgb04c_outE0 on DMG in GBHawk",
				"halt.ifandie_ei_halt_m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.ifandie_ei_halt_m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0int_halt_m0stat_scx2_1a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0int_halt_m0stat_scx2_1a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0int_halt_m0stat_scx2_2a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0int_halt_m0stat_scx2_2a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0int_halt_m0stat_scx2_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0int_halt_m0stat_scx2_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0int_halt_m0stat_scx2_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0int_halt_m0stat_scx2_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0int_halt_m0stat_scx3_2b_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"halt.late_m0int_halt_m0stat_scx3_2b_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_dec_scx3_1_dmg08_cgb04c_out7 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_dec_scx3_1_dmg08_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx2_1a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx2_1a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx2_2a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx2_2a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx2_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx2_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx2_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx2_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx3_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx3_3a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.late_m0irq_halt_m0stat_scx3_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.late_m0irq_halt_m0stat_scx3_4a_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0int_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0int_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0int_m0stat_scx2_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0int_m0stat_scx2_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0int_m0stat_scx4_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0int_m0stat_scx4_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0int_m0stat_scx5_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0int_m0stat_scx5_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0irq_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0irq_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0irq_m0stat_scx2_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0irq_m0stat_scx2_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0irq_m0stat_scx4_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0irq_m0stat_scx4_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.m0irq_m0stat_scx5_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.m0irq_m0stat_scx5_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.noime_ifandie_m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.noime_ifandie_m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"halt.noime_m2irq_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"halt.noime_m2irq_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.hdma_vs_m0_scx1_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.hdma_vs_m0_scx1_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.hdma_vs_m0_scx2_halt_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.hdma_vs_m0_scx2_halt_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.hdma_vs_m0_scx3_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.hdma_vs_m0_scx3_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_ei_scx1_2_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_ei_scx1_2_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_ei_scx2_2_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_ei_scx2_2_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_ie_scx1_2_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_ie_scx1_2_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_ie_scx2_2_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_ie_scx2_2_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_tima_scx1_1_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_tima_scx1_1_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_tima_scx1_halt_1_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_tima_scx1_halt_1_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_tima_scx2_1_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_tima_scx2_1_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_hdma_vs_tima_scx2_halt_1_cgb04c_out1234 on CGB_C in SameBoy",
				"irq_precedence.late_hdma_vs_tima_scx2_halt_1_cgb04c_out1234 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_m0irq_retrigger_ds_1_cgb04c_outE2 on CGB_C in SameBoy",
				"irq_precedence.late_m0irq_retrigger_ds_1_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_m0irq_retrigger_scx1_1_dmg08_cgb04c_outE2 on CGB_C in GBHawk",
				"irq_precedence.late_m0irq_retrigger_scx1_1_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"irq_precedence.late_m0irq_retrigger_scx1_1_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_m0irq_retrigger_scx1_1_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"irq_precedence.late_m0irq_retrigger_scx1_ds_1_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_m0irq_vs_tima_scx3_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"irq_precedence.late_m0irq_vs_tima_scx3_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"irq_precedence.late_m0irq_vs_tima_scx3_halt_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"irq_precedence.late_m0irq_vs_tima_scx3_halt_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc8fint_m1stat_1_cgb04c_outC4 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc8fint_m1stat_1_cgb04c_outC4 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc8fint_m1stat_ds_1_cgb04c_outC0 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc98int_ly_count_ds_2_cgb04c_out9A on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc98int_ly_count_ds_2_cgb04c_out9A on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc98int_ly_count_ds_2_cgb04c_out9A on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m0irq_count_scx1_ds_2_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc99int_m0irq_count_scx2_ds_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m0irq_count_scx2_ds_1_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx1_ds_2_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx2_ds_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx2_ds_1_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx3_1_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx3_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m0stat_count_scx3_1_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m2irq_count_ds_1_cgb04c_out98 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m2irq_count_ds_1_cgb04c_out98 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m2irq_count_ds_2_cgb04c_out91 on CGB_C in SameBoy",
				"lcd_offset.offset1_lyc99int_m2irq_count_ds_2_cgb04c_out91 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset1_lyc99int_m2stat_count_ds_2_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset1_lyc99int_m3stat_count_ds_2_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset2_lyc8fint_m1stat_1_cgb04c_outC4 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc8fint_m1stat_1_cgb04c_outC4 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in GBHawk",
				"lcd_offset.offset2_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc98int_ly_count_3_cgb04c_out9A on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc98int_ly_count_3_cgb04c_out9A on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx1_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx1_2_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx2_1_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx2_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx2_1_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc99int_m0stat_count_scx2_2_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in GBHawk",
				"lcd_offset.offset2_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy",
				"lcd_offset.offset2_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset2_lyc99int_m2irq_count_2_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc8fint_m1irq_1_cgb04c_outE0 on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc8fint_m1stat_1_cgb04c_outC0 on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc98int_ly_count_1_cgb04c_out99 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset3_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc98int_ly_count_2_cgb04c_out9A on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset3_lyc99int_m0stat_count_scx1_1_cgb04c_out90 on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc99int_m0stat_count_scx1_1_cgb04c_out90 on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc99int_m0stat_count_scx1_1_cgb04c_out90 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset3_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc99int_m2irq_count_1_cgb04c_out98 on CGB_C in SameBoy (no BIOS)",
				"lcd_offset.offset3_lyc99int_m2irq_count_2_cgb04c_out91 on CGB_C in GBHawk",
				"lcd_offset.offset3_lyc99int_m2irq_count_2_cgb04c_out91 on CGB_C in SameBoy",
				"lcd_offset.offset3_lyc99int_m2irq_count_2_cgb04c_out91 on CGB_C in SameBoy (no BIOS)",
				"lcdirq_precedence.lcdirqprecedence_lycirq_ly90_lcdstat68_dmg08_cgb04c_out1 on CGB_C in GBHawk",
				"lcdirq_precedence.m2irq_ly00_lcdstat30_dmg08_cgb04c_out0 on DMG in GBHawk",
				"ly0.lycint152_ly0stat_2_dmg08_cgb04c_outC0 on CGB_C in GBHawk",
				"ly0.lycint152_ly0stat_2_dmg08_cgb04c_outC0 on CGB_C in SameBoy",
				"ly0.lycint152_ly0stat_2_dmg08_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_ly1_m2irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"ly0.lycint152_ly1_m2irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_ly153_2_dmg08_cgb04c_out99 on CGB_C in SameBoy",
				"ly0.lycint152_ly153_2_dmg08_cgb04c_out99 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_ly153_3_dmg08_cgb04c_out00 on CGB_C in GBHawk",
				"ly0.lycint152_ly153_3_dmg08_cgb04c_out00 on CGB_C in SameBoy",
				"ly0.lycint152_ly153_3_dmg08_cgb04c_out00 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc0flag_4_dmg08_cgb04c_outC0 on CGB_C in GBHawk",
				"ly0.lycint152_lyc0flag_4_dmg08_cgb04c_outC0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc0flag_4_dmg08_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc0irq_ifw_1_dmg08_cgb04c_outE2 on DMG in SameBoy",
				"ly0.lycint152_lyc0irq_ifw_1_dmg08_cgb04c_outE2 on DMG in SameBoy (no BIOS)",
				"ly0.lycint152_lyc0irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in GBHawk",
				"ly0.lycint152_lyc0irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc0irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153flag_2_dmg08_cgb04c_outC5 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153flag_2_dmg08_cgb04c_outC5 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153flag_3_dmg08_cgb04c_outC1 on CGB_C in GBHawk",
				"ly0.lycint152_lyc153flag_ds_2_cgb04c_outC5 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153flag_ds_2_cgb04c_outC5 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153flag_ds_3_cgb04c_outC5 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153flag_ds_3_cgb04c_outC5 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_ds_2_cgb04c_outE2 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_ds_2_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_ifw_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_ifw_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_ifw_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_ifw_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in GBHawk",
				"ly0.lycint152_lyc153irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_late_retrigger_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_late_retrigger_2_dmg08_cgb04c_outE0 on DMG in SameBoy",
				"ly0.lycint152_lyc153irq_late_retrigger_2_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"ly0.lycint152_lyc153irq_late_retrigger_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"ly0.lycint152_lyc153irq_late_retrigger_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"ly0.lycint152_m0irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"ly0.lycint152_m0irq_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lyc0int_m0irq.lyc0int_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"lyc0int_m0irq.lyc0int_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lyc0int_m0irq.lyc0int_m0irq_ds_2_cgb04c_out2 on CGB_C in SameBoy",
				"lyc0int_m0irq.lyc0int_m0irq_ds_2_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lyc153int_m2irq.lyc153int_m2irq_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"lyc153int_m2irq.lyc153int_m2irq_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"lyc153int_m2irq.lyc153int_m2irq_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lyc153int_m2irq.lyc153int_m2irq_late_retrigger_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"lyc153int_m2irq.lyc153int_m2irq_late_retrigger_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.early_ff41_response_1_cgb04c_out0 on CGB_C in SameBoy",
				"lycEnable.early_ff41_response_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.early_ff45_response_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"lycEnable.early_ff45_response_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy",
				"lycEnable.ff41_disable_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"lycEnable.ff45_disable_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy",
				"lycEnable.ff45_disable_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff45_disable_ds_1_cgb04c_out1 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_2_dmg08_out3_cgb04c_out1 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"lycEnable.ff45_enable_weirdpoint_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff45_enable_weirdpoint_3_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy",
				"lycEnable.ff45_enable_weirdpoint_3_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff45_enable_weirdpoint_3_dmg08_out1_cgb04c_out3 on DMG in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_ds_2_cgb04c_out1 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_ds_3_cgb04c_out1 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_ds_lcdoffset1_3_cgb04c_out0 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_ds_lcdoffset1_3_cgb04c_out0 on CGB_C in SameBoy",
				"lycEnable.ff45_enable_weirdpoint_ds_lcdoffset1_3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff45_enable_weirdpoint_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"lycEnable.ff45_enable_weirdpoint_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.ff45_enable_weirdpoint_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"lycEnable.ff45_enable_weirdpoint_lcdoffset1_2_cgb04c_out0 on CGB_C in SameBoy",
				"lycEnable.ff45_enable_weirdpoint_lcdoffset1_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.late_ff41_enable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"lycEnable.late_ff41_enable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.late_ff41_enable_after_m2int_disable_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff41_enable_after_m2int_disable_dmg08_cgb04c_out2 on DMG in GBHawk",
				"lycEnable.late_ff41_enable_after_m2int_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff41_enable_after_m2int_dmg08_cgb04c_out2 on DMG in GBHawk",
				"lycEnable.late_ff41_enable_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"lycEnable.late_ff41_enable_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff41_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff41_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"lycEnable.late_ff41_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.late_ff45_enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"lycEnable.late_ff45_enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.late_ff45_enable_after_m2int_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff45_enable_after_m2int_dmg08_cgb04c_out2 on DMG in GBHawk",
				"lycEnable.late_ff45_enable_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"lycEnable.late_ff45_enable_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff45_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"lycEnable.late_ff45_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"lycEnable.late_ff45_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on DMG in SameBoy",
				"lycEnable.lcdoff_lycirqen_1_dmg08_cgb04c_outE2 on DMG in SameBoy (no BIOS)",
				"lycEnable.lcdoff_lycirqen_4_dmg08_outE2_cgb04c_outE0 on DMG in GBHawk",
				"lycEnable.lcdoff_lycirqen_4_dmg08_outE2_cgb04c_outE0 on DMG in SameBoy",
				"lycEnable.lcdoff_lycirqen_4_dmg08_outE2_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"lycEnable.lyc_ff45_disable2_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy",
				"lycEnable.lyc_ff45_disable2_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc_ff45_disable2_ds_1_cgb04c_out1 on CGB_C in GBHawk",
				"lycEnable.lyc_ff45_trigger_delay_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"lycEnable.lyc_ff45_trigger_delay_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc_ff45_trigger_delay_ds_1_cgb04c_out0 on CGB_C in GBHawk", // completely blank
				"lycEnable.lyc_ff45_trigger_delay_ds_2_cgb04c_out2 on CGB_C in GBHawk", // completely blank
				"lycEnable.lyc0_ff41_disable_2_dmg08_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc0_ff41_disable_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc0_ff41_disable_2_dmg08_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc0_ff45_disable_2_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc0_ff45_disable_2_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc0_ff45_disable_ds_1_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc0_late_ff45_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc0_late_ff45_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on DMG in GBHawk",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on DMG in SameBoy",
				"lycEnable.lyc0_m1disable_2_dmg08_outE2_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_enable_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_enable_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_enable_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_enable_m1disable_2_dmg08_outE2_cgb04c_outE0 on DMG in GBHawk",
				"lycEnable.lyc153_late_enable_m1disable_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_enable_m1disable_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff41_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff41_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff41_enable_ds_1_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff41_enable_ds_lcdoffset1_1_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff41_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff41_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff41_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_3_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_3_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_3_dmg08_outE0_cgb04c_outE2 on DMG in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_2_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_3_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_4_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_4_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_ds_4_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_ds_5_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_5_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_ds_5_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_ds_lcdoffset1_1_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_ds_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_ds_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_ff45_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_ff45_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_ff45_enable_lcdoffset1_1_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lyc153_late_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_m1disable_2_dmg08_outE2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_late_m1disable_2_dmg08_outE2_cgb04c_outE0 on DMG in GBHawk",
				"lycEnable.lyc153_late_m1disable_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_late_m1disable_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lyc153_m1disable_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lyc153_m1disable_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lycwirq_trigger_ly00_stat50_3_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_1_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_1_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_lcdoffset1_1_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lycwirq_trigger_ly00_stat50_ds_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycEnable.lycwirq_trigger_ly00_stat50_lcdoffset1_1_cgb04c_outE0 on CGB_C in GBHawk",
				"lycEnable.lycwirq_trigger_ly00_stat50_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy",
				"lycEnable.lycwirq_trigger_ly00_stat50_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"lycint_ly.lycint_ly_2_dmg08_cgb04c_out6 on CGB_C in SameBoy",
				"lycint_ly.lycint_ly_2_dmg08_cgb04c_out6 on CGB_C in SameBoy (no BIOS)",
				"lycint_ly.lycint_ly_ds_2_cgb04c_out6 on CGB_C in SameBoy",
				"lycint_ly.lycint_ly_ds_2_cgb04c_out6 on CGB_C in SameBoy (no BIOS)",
				"lycint_lycflag.lycint_lycflag_4_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"lycint_lycflag.lycint_lycflag_4_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"lycint_lycflag.lycint_lycflag_4_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"lycm2int.lyc0m2int_m2irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"lycm2int.lyc0m2int_m2irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"lycm2int.lycm2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"lycm2int.lycm2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0enable.disable_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.disable_scx3_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m0enable.disable_scx3_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy",
				"m0enable.disable_scx3_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m0enable.disable_scx4_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.disable_scx4_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.disable_scx4_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.disable_scx5_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"m0enable.disable_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"m0enable.disable_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m0enable.disable_scx7_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m0enable.disable_scx7_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy",
				"m0enable.disable_scx7_2_dmg08_out0_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_2_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_ds_2_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_ds_2_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_ds_2_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_ds_3_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_ds_3_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_ds_3_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.enable_wxA6_2x_spxA7_ds_4_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.enable_wxA6_2x_spxA7_ds_4_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.enable_wxA6_2x_spxA7_ds_4_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.late_enable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.late_enable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.late_enable_2_dmg08_out2_cgb04c_out0 on CGB_C in GBHawk",
				"m0enable.late_enable_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m0enable.late_enable_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m0enable.late_enable_ds_2_cgb04c_out1 on CGB_C in GBHawk",
				"m0enable.late_enable_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.late_enable_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.late_enable_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"m0enable.late_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.late_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff41_2_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"m0enable.lycdisable_ff41_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy",
				"m0enable.lycdisable_ff41_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff41_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.lycdisable_ff41_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff41_scx1_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m0enable.lycdisable_ff41_scx1_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff41_scx3_2_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"m0enable.lycdisable_ff41_scx3_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy",
				"m0enable.lycdisable_ff41_scx3_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff45_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m0enable.lycdisable_ff45_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff45_3_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"m0enable.lycdisable_ff45_scx1_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m0enable.lycdisable_ff45_scx2_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m0enable.lycdisable_ff45_scx2_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0enable.lycdisable_ff45_scx3_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m0enable.lycdisable_ff45_scx3_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0enable.reenable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m0enable.reenable_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m0int_m0stat.m0int_m0stat_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"m0int_m0stat.m0int_m0stat_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0int_m0stat.m0int_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m0int_m0stat.m0int_m0stat_scx2_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m0int_m3stat.m0int_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m0int_m3stat.m0int_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m0enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m0enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m0enable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m0enable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m0enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in GBHawk",
				"m1.ly143_late_m0enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m0enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m0enable_lcdoffset1_1_cgb04c_out3 on CGB_C in GBHawk",
				"m1.ly143_late_m2enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m2enable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m2enable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m2enable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.ly143_late_m2enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in GBHawk",
				"m1.ly143_late_m2enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.ly143_late_m2enable_ds_lcdoffset1_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lyc143_late_m0enable_lycdisable_2_dmg08_cgb04c_out1 on DMG in GBHawk",
				"m1.lyc143_late_m0enable_lycdisable_3_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lyc143_late_m0enable_lycdisable_3_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lyc143_late_m0enable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lyc143_late_m0enable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lyc143_late_m2enable_lycdisable_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"m1.lyc143_late_m2enable_lycdisable_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lyc143_late_m2enable_lycdisable_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lyc143_late_m2enable_lycdisable_2_dmg08_cgb04c_out1 on DMG in GBHawk",
				"m1.lyc143_late_m2enable_lycdisable_2_dmg08_cgb04c_out1 on DMG in SameBoy",
				"m1.lyc143_late_m2enable_lycdisable_2_dmg08_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"m1.lyc143_late_m2enable_lycdisable_3_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lyc143_late_m2enable_lycdisable_3_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lyc143_late_m2enable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lyc143_late_m2enable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_m1intirq_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m1.lycint_m1intirq_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_m1intirq_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lycint_m1intirq_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_m1stat_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lycint_m1stat_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_vblankintirq_1_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lycint_vblankintirq_1_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_vblankintirq_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m1.lycint_vblankintirq_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_vblankirq_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lycint_vblankirq_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint_vblankirq_late_retrigger_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m1.lycint_vblankirq_late_retrigger_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint143_m1irq_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m1.lycint143_m1irq_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint143_m1irq_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"m1.lycint143_m1irq_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.lycint143_m1irq_late_retrigger_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.lycint143_m1irq_late_retrigger_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_disable_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m1.m1irq_disable_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_disable_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"m1.m1irq_disable_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_enable_after_lyc144_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy",
				"m1.m1irq_enable_after_lyc144_2_dmg08_out1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_enable_after_lyc144_2_dmg08_out1_cgb04c_out3 on DMG in GBHawk",
				"m1.m1irq_late_enable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m1.m1irq_late_enable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_late_enable_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"m1.m1irq_late_enable_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"m1.m1irq_m0disable_2_dmg08_out3_cgb04c_out1 on CGB_C in GBHawk",
				"m1.m1irq_m0disable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m0disable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m0disable_2_dmg08_out3_cgb04c_out1 on DMG in GBHawk",
				"m1.m1irq_m0disable_3_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m0disable_3_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m0disable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m0disable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m0enable_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"m1.m1irq_m2disable_lycdisable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m2disable_lycdisable_2_dmg08_out3_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m2disable_lycdisable_2_dmg08_out3_cgb04c_out1 on DMG in GBHawk",
				"m1.m1irq_m2disable_lycdisable_3_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m2disable_lycdisable_3_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m2disable_lycdisable_3_dmg08_cgb04c_out1 on DMG in SameBoy",
				"m1.m1irq_m2disable_lycdisable_3_dmg08_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"m1.m1irq_m2disable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m2disable_lycdisable_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m2enable_lyc_1_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m2enable_lyc_1_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m1irq_m2enable_lyc_1_dmg08_cgb04c_out1 on DMG in SameBoy",
				"m1.m1irq_m2enable_lyc_1_dmg08_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"m1.m1irq_m2enable_lyc_2_dmg08_out1_cgb04c_out3 on DMG in GBHawk",
				"m1.m1irq_m2enable_lyc_2_dmg08_out1_cgb04c_out3 on DMG in SameBoy",
				"m1.m1irq_m2enable_lyc_2_dmg08_out1_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"m1.m1irq_m2enable_lyc_ds_1_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m1irq_m2enable_lyc_ds_1_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m2m1irq_ifw_2_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m2m1irq_ifw_2_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m1.m2m1irq_ifw_2_dmg08_cgb04c_out1 on DMG in SameBoy",
				"m1.m2m1irq_ifw_2_dmg08_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"m1.m2m1irq_ifw_ds_2_cgb04c_out1 on CGB_C in SameBoy",
				"m1.m2m1irq_ifw_ds_2_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"m2enable.disable_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2enable.enable_after_lycint_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m2enable.enable_after_lycint_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2enable.enable_after_lycint_disable_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m2enable.enable_after_lycint_disable_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_1_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_after_lycint_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_after_lycint_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_after_lycint_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_after_lycint_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_after_lycint_disable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_after_lycint_disable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_after_lycint_disable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_after_lycint_disable_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"m2enable.late_enable_after_lycint_disable_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m2enable.late_enable_after_lycint_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_after_lycint_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_after_lycint_disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_after_lycint_disable_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_lcdoffset2_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_lcdoffset3_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_ly0_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_ly0_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_ly0_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_ly0_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_ly0_ds_lcdoffset1_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_ly0_lcdoffset2_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_ly0_lcdoffset2_2_cgb04c_out0 on CGB_C in SameBoy",
				"m2enable.late_enable_m0disable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_m0disable_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_m0disable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_m0disable_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"m2enable.late_enable_m0disable_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m2enable.late_enable_m0disable_2_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_m0disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_m0disable_2_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_m0disable_2_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_m0disable_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_m0disable_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_m0disable_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_m1disable_ly0_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_enable_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m2enable.late_enable_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_enable_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy",
				"m2enable.late_enable_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"m2enable.late_enable_m1disable_ly0_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.late_enable_m1disable_ly0_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.late_enable_m1disable_ly0_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_m1disable_ly0_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.late_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m2enable.late_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2enable.late_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy",
				"m2enable.late_m1disable_ly0_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"m2enable.late_m1disable_ly0_3_dmg08_cgb04c_out0 on DMG in GBHawk",
				"m2enable.lyc0_late_m2enable_lycdisable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.lyc0_late_m2enable_lycdisable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m2enable.lyc0_late_m2enable_lycdisable_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2enable.lyc0_late_m2enable_lycdisable_2_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"m2enable.lyc0_late_m2enable_lycdisable_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy",
				"m2enable.lyc0_late_m2enable_lycdisable_2_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"m2enable.lyc1_late_m2enable_lycdisable_1_dmg08_out0_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.lyc1_late_m2enable_lycdisable_1_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.lyc1_late_m2enable_lycdisable_1_dmg08_out0_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.lyc1_late_m2enable_lycdisable_1_dmg08_out0_cgb04c_out2 on DMG in GBHawk",
				"m2enable.lyc1_late_m2enable_lycdisable_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.lyc1_late_m2enable_lycdisable_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.lyc1_late_m2enable_lycdisable_ds_3_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.lyc1_late_m2enable_lycdisable_ds_3_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.lyc1_late_m2enable_lycdisable_ds_3_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.lyc1_m2irq_late_lyc255_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy",
				"m2enable.lyc1_m2irq_late_lyc255_2_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2enable.lyc1_m2irq_late_lyc255_ds_1_cgb04c_out2 on CGB_C in GBHawk",
				"m2enable.lyc1_m2irq_late_lycdisable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.lyc1_m2irq_late_lycdisable_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"m2enable.lyc1_m2irq_late_lycdisable_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m2enable.lyc1_m2irq_late_lycdisable_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.lyc1_m2irq_late_lycdisable_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2enable.m2_late_m0disable_1_dmg08_cgb04c_out2 on DMG in GBHawk",
				"m2enable.m2_late_m0disable_1_dmg08_cgb04c_out2 on DMG in SameBoy",
				"m2enable.m2_late_m0disable_1_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"m2enable.m2_late_m0disable_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2enable.m2_late_m0disable_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx3_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_di_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx3_di_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_ei_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx3_ei_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_ie_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx3_ie_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx3_ifw_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"m2int_m0irq.m2int_m0irq_scx3_reti_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx3_reti_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_3_dmg08_cgb04c_out8 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_3_dmg08_cgb04c_out8 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx4_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0irq.m2int_m0irq_scx5_ds_1_cgb04c_out1 on CGB_C in SameBoy",
				"m2int_m0irq.m2int_m0irq_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0stat.m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0stat.m2int_m0stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0stat.m2int_m0stat_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"m2int_m0stat.m2int_m0stat_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m0stat.m2int_m0stat_ds_2_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2irq.m2int_m2irq_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2irq.m2int_m2irq_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m2irq.m2int_m2irq_ifw_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2irq.m2int_m2irq_late_retrigger_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m2irq.m2int_m2irq_late_retrigger_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2stat.m2int_m2stat_1_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m2stat.m2int_m2stat_1_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2stat.m2int_m2stat_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m2stat.m2int_m2stat_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2stat.m2int_m2stat_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2stat.m2int_scx4_m2stat_ds_1_cgb04c_out2 on CGB_C in SameBoy",
				"m2int_m2stat.m2int_scx4_m2stat_ds_1_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"m2int_m2stat.m2int_scx4_m2stat_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.m2int_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.m2int_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.m2int_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.m2int_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.nobg.m2int_nobg_m3stat_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.nobg.m2int_nobg_m3stat_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.late_scx4_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.late_scx4_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.late_scx4_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"m2int_m3stat.scx.late_scx4_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.late_scx4_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.late_scx4_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx1_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.m2int_scx1_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx1_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx2_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx3_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.m2int_scx3_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx4_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.m2int_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx6_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx7_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"m2int_m3stat.scx.m2int_scx7_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx8_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"m2int_m3stat.scx.m2int_scx8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycflag_statwirq_2_dmg08_out2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_00_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_00_bf_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_bf_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_bf_bf_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_2_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_ds_1_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_ds_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_ds_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_ds_lcdoffset1_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_ly00_10_50_ds_lcdoffset1_2_cgb04c_outE2 on CGB_C in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_ly94_00_50_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_ly94_10_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_ly94_10_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_early_ly44_lyc44_08_40_9_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_early_ly44_lyc44_08_40_9_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_2_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_3_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_4_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_4_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_4_dmg08_cgb04c_outE0 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_4_dmg08_cgb04c_outE0 on DMG in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_4_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_ds_1_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_ds_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_late_ly44_lyc44_08_40_ds_3_cgb04c_outE2 on CGB_C in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_00_40_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_00_48_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_08_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_08_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_b7_40_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_b7_f7_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_bf_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"miscmstatirq.lycstatwirq_trigger_m0_ly44_lyc44_bf_40_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.m0statwirq_scx3_1_dmg08_out0 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_scx3_1_dmg08_out0 on DMG in SameBoy",
				"miscmstatirq.m0statwirq_scx3_1_dmg08_out0 on DMG in SameBoy (no BIOS)",
				"miscmstatirq.m0statwirq_trigger_00_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_00_08_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_00_f7_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_00_ff_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_f7_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_f7_08_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_f7_f7_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_f7_ff_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m0statwirq_trigger_ly44_lyc44_00_08_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_3_dmg08_out2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_00_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_00_10_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_00_ef_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_00_ff_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ef_00_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ef_10_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ef_ef_dmg08_out2_cgb04c_out0 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ef_ff_dmg08_out2_cgb04c_out2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ly94_lyc94_00_10_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ly94_lyc94_00_50_dmg08_cgb04c_outE2 on DMG in GBHawk",
				"miscmstatirq.m1statwirq_trigger_ly94_lyc94_40_50_2_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy",
				"miscmstatirq.m1statwirq_trigger_ly94_lyc94_40_50_2_dmg08_outE0_cgb04c_outE2 on CGB_C in SameBoy (no BIOS)",
				"miscmstatirq.m1statwirq_trigger_ly94_lyc94_40_50_2_dmg08_outE0_cgb04c_outE2 on DMG in GBHawk",
				"oam_access.10spritesprline_postread_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.10spritesprline_postread_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oam_access.10spritesprline_postread_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oam_access.10spritesprline_postread_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oam_access.midwrite_2_dmg08_out1_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.postread_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"oam_access.postread_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oam_access.postread_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.postread_scx3_2_dmg08_xout1_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.postread_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"oam_access.postread_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oam_access.postwrite_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oam_access.postwrite_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oam_access.postwrite_2_scx3_dmg08_cgb04c_out1 on CGB_C in GBHawk",
				"oam_access.postwrite_2_scx3_dmg08_cgb04c_out1 on DMG in GBHawk",
				"oam_access.postwrite_ds_2_cgb04c_out1 on CGB_C in GBHawk",
				"oam_access.postwrite_scx1_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"oam_access.postwrite_scx1_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oam_access.preread_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.preread_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"oam_access.preread_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oam_access.preread_ds_lcdoffset1_1_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.preread_lcdoffset1_1_cgb04c_out0 on CGB_C in GBHawk",
				"oam_access.preread_lcdoffset1_1_cgb04c_out0 on CGB_C in SameBoy",
				"oam_access.preread_lcdoffset1_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oam_access.prewrite_1_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"oam_access.prewrite_1_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"oam_access.prewrite_ds_1_cgb04c_out1 on CGB_C in GBHawk",
				"oam_access.prewrite_ds_1_cgb04c_out1 on CGB_C in SameBoy",
				"oam_access.prewrite_ds_1_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"oam_access.prewrite_ds_lcdoffset1_1_cgb04c_out1 on CGB_C in GBHawk",
				"oam_access.prewrite_lcdoffset1_1_cgb04c_out1 on CGB_C in GBHawk",
				"oam_access.prewrite_lcdoffset1_1_cgb04c_out1 on CGB_C in SameBoy",
				"oam_access.prewrite_lcdoffset1_1_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"oamdma.late_sp00x_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp00x_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.late_sp00y_2_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp00y_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"oamdma.late_sp01x_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp01x_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp01y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.late_sp01y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp01y_2_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.late_sp01y_2_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp01y_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"oamdma.late_sp02x_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.late_sp02y_2_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp39x_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp39x_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.late_sp39x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.late_sp39x_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp39x_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"oamdma.late_sp39x_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp39x_3_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp39x_4_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.late_sp39x_4_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp39x_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.late_sp39y_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.late_sp39y_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.late_sp39y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.late_sp39y_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.late_sp39y_2_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.late_sp39y_2_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.late_sp39y_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_late_halt_stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.oamdma_late_halt_stat_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_late_halt_stat_1_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_late_halt_stat_1_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_late_halt_stat_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_late_halt_stat_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.oamdma_late_speedchange_stat_1_cgb04c_out0 on CGB_C in SameBoy",
				"oamdma.oamdma_late_speedchange_stat_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_late_speedchange_stat_2_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on DMG in GBHawk",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on DMG in SameBoy",
				"oamdma.oamdma_src0000_busycallAFFF_dmg08_cgb04c_outFF8F on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busyint0002_dmg08_cgb04c_outFF941234 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypop7FFF_dmg08_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypop7FFF_dmg08_cgb04c_out657665AA on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypop9FFF_2_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypop9FFF_2_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypop9FFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypop9FFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypopBFFF_2_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in SameBoy",
				"oamdma.oamdma_src0000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyread8000_dmg08_cgb04c_out1 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyread8000_dmg08_cgb04c_out1 on DMG in GBHawk",
				"oamdma.oamdma_src0000_busyreadA000_1_dmg08_cgb04c_out5 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyreadC000_1_dmg08_out5_cgb04c_out1 on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on CGB_C in GBHawk",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on CGB_C in SameBoy",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on DMG in GBHawk",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on DMG in SameBoy",
				"oamdma.oamdma_src0000_busyrst0002_dmg08_cgb04c_outFF8DFA9E on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src0000_srambankchange_1_dmg08_cgb04c_out4 on DMG in SameBoy",
				"oamdma.oamdma_src0000_srambankchange_1_dmg08_cgb04c_out4 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypop7FFF_dmg08_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypop7FFF_dmg08_cgb04c_out657665AA on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypop9FFF_2_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypop9FFF_2_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypop9FFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypop9FFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypopBFFF_2_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopBFFF_2_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypopBFFF_2_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushA001_2_dmg08_cgb04c_out5576AAFF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushC001_2_dmg08_out55AAFF34_cgb04c_out65AAFF55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy",
				"oamdma.oamdma_src7F00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in GBHawk",
				"oamdma.oamdma_src7F00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in SameBoy",
				"oamdma.oamdma_src7F00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_src7F00_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_src7F00_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in SameBoy",
				"oamdma.oamdma_src8000_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src8000_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in SameBoy",
				"oamdma.oamdma_src8000_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src8000_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in SameBoy",
				"oamdma.oamdma_src8000_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src8000_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypopBFFF_2_dmg08_cgb04c_out6576FFAA on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypopBFFF_2_dmg08_cgb04c_out6576FFAA on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypopBFFF_dmg08_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypopBFFF_dmg08_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypopDFFF_dmg08_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypopDFFF_dmg08_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypush8001_dmg08_out55761234_cgb04c_out00761234 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypush8001_dmg08_out55761234_cgb04c_out00761234 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushA001_2_dmg08_out65AA12FF_cgb04c_out650012FF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushA001_2_dmg08_out65AA12FF_cgb04c_out650012FF on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushA001_dmg08_out65AA1255_cgb04c_out65001255 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushA001_dmg08_out65AA1255_cgb04c_out65001255 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushC001_2_dmg08_cgb04c_out6576FF55 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushC001_2_dmg08_cgb04c_out6576FF55 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushC001_dmg08_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushC001_dmg08_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushE001_dmg08_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushE001_dmg08_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busyreadA000_dmg08_cgb04c_out1 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busyreadC000_dmg08_cgb04c_out1 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busyreadC000_dmg08_cgb04c_out1 on DMG in GBHawk",
				"oamdma.oamdma_src8000_busywrite8000_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_busywrite8000_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_src8000_srcchangeC000_busyread8000_dmg08_cgb04c_out1 on CGB_C in GBHawk",
				"oamdma.oamdma_src8000_srcchangeC000_busyread8000_dmg08_cgb04c_out1 on DMG in GBHawk",
				"oamdma.oamdma_src8000_vrambankchange_2_cgb04c_out4 on CGB_C in SameBoy",
				"oamdma.oamdma_src8000_vrambankchange_2_cgb04c_out4 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src8000_vrambankchange_4_cgb04c_out3 on CGB_C in SameBoy",
				"oamdma.oamdma_src8000_vrambankchange_4_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src9F00_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in SameBoy",
				"oamdma.oamdma_src9F00_busypop7FFF_dmg08_out65765576_cgb04c_out65005576 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src9F00_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in SameBoy",
				"oamdma.oamdma_src9F00_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src9F00_busypop9FFF_2_dmg08_out657665FF_cgb04c_out007665FF on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in SameBoy",
				"oamdma.oamdma_src9F00_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_src9F00_busypop9FFF_dmg08_out657665AA_cgb04c_out007665AA on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypopBFFF_2_dmg08_cgb04c_out6576FFAA on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypopBFFF_2_dmg08_cgb04c_out6576FFAA on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypopBFFF_dmg08_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypopBFFF_dmg08_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypopDFFF_dmg08_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypopDFFF_dmg08_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypush8001_dmg08_out55761234_cgb04c_out00761234 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypush8001_dmg08_out55761234_cgb04c_out00761234 on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushA001_2_dmg08_out65AA12FF_cgb04c_out650012FF on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushA001_2_dmg08_out65AA12FF_cgb04c_out650012FF on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushA001_dmg08_out65AA1255_cgb04c_out65001255 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushA001_dmg08_out65AA1255_cgb04c_out65001255 on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushC001_2_dmg08_cgb04c_out6576FF55 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushC001_2_dmg08_cgb04c_out6576FF55 on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushC001_dmg08_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushC001_dmg08_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushE001_dmg08_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushE001_dmg08_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_src9F00_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_src9F00_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypop7FFF_dmg08_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypop7FFF_dmg08_cgb04c_out657665AA on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypop9FFF_2_dmg08_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypop9FFF_2_dmg08_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypop9FFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypop9FFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopBFFF_2_dmg08_outFFFFFFFF_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypopFFFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypopFFFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in SameBoy",
				"oamdma.oamdma_srcA000_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in SameBoy",
				"oamdma.oamdma_srcA000_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busyread0000_1_dmg08_cgb04c_out5 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busyread0000_1_dmg08_cgb04c_out5 on DMG in GBHawk",
				"oamdma.oamdma_srcA000_busyreadC000_1_dmg08_out5_cgb04c_out1 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busywrite4000_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"oamdma.oamdma_srcA000_busywrite4000_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"oamdma.oamdma_srcA000_busywrite4000_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcA000_busywrite4000_dmg08_cgb04c_out2 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypop7FFF_dmg08_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypop7FFF_dmg08_cgb04c_out657665AA on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypop9FFF_2_dmg08_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypop9FFF_2_dmg08_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypop9FFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypop9FFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopBFFF_2_dmg08_outFFFFFFFF_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopBFFF_2_dmg08_outFFFFFFFF_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypopBFFF_2_dmg08_outFFFFFFFF_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypopBFFF_dmg08_out65766576_cgb04c_out657665AA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopDFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopEFFF_dmg08_out65766576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFDFF_dmg08_out657665FF_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFFFF_dmg08_cgb04c_out65765576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypopFFFF_dmg08_cgb04c_out65765576 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypush0001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypush0001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypush8001_dmg08_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypush8001_dmg08_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in SameBoy",
				"oamdma.oamdma_srcBF00_busypushA001_2_dmg08_cgb04c_out55FFAAFF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushA001_dmg08_cgb04c_out5576AA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushA001_dmg08_cgb04c_out5576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in SameBoy",
				"oamdma.oamdma_srcBF00_busypushC001_2_dmg08_out55AAFF34_cgb04c_outFFAAFF55 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushC001_dmg08_out55AA1234_cgb04c_out65AA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushE001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushF001_dmg08_out55AA1234_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy",
				"oamdma.oamdma_srcBF00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcBF00_busypushFE01_dmg08_out65AA1298_cgb04c_out6576AA98 on DMG in GBHawk",
				"oamdma.oamdma_srcBF00_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_srcBF00_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypop7FFF_dmg08_out657665AA_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypop7FFF_dmg08_out657665AA_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypop9FFF_2_dmg08_out65765576_cgb04c_out657655FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypop9FFF_2_dmg08_out65765576_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypop9FFF_dmg08_out65765576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypop9FFF_dmg08_out65765576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopDFFF_dmg08_cgb04c_out65766576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypopDFFF_dmg08_cgb04c_out65766576 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopEFFF_dmg08_cgb04c_out65766576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypopEFFF_dmg08_cgb04c_out65766576 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopFDFF_dmg08_cgb04c_out657665FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypopFDFF_dmg08_cgb04c_out657665FF on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypopFFFF_dmg08_out65765576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypush0001_dmg08_out4576AA34_cgb04c_out6576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypush8001_dmg08_out65221255_cgb04c_out65761255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypush8001_dmg08_out65221255_cgb04c_out65761255 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out6576AAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out6576AAFF on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushA001_dmg08_out4576AA34_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushA001_dmg08_out4576AA34_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushC001_2_dmg08_out4522FF34_cgb04c_out6576FF34 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushC001_dmg08_out45221234_cgb04c_out6576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushE001_dmg08_out45221234_cgb04c_out65761234 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushE001_dmg08_out45221234_cgb04c_out65761234 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushF001_dmg08_out45221234_cgb04c_out65761234 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushF001_dmg08_out45221234_cgb04c_out65761234 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushFE01_dmg08_out65221298_cgb04c_out65761298 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushFE01_dmg08_out65221298_cgb04c_out65761298 on DMG in GBHawk",
				"oamdma.oamdma_srcC000_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcC000_srambankchange_1_dmg08_out4_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcD000_wrambankchange_2_cgb04c_out4 on CGB_C in SameBoy",
				"oamdma.oamdma_srcD000_wrambankchange_2_cgb04c_out4 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcDF00_busypop7FFF_dmg08_out657665AA_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypop7FFF_dmg08_out657665AA_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypop9FFF_2_dmg08_out65765576_cgb04c_out657655FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypop9FFF_2_dmg08_out65765576_cgb04c_out657655FF on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypop9FFF_dmg08_out65765576_cgb04c_out657655AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypop9FFF_dmg08_out65765576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopDFFF_dmg08_cgb04c_out65766576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypopDFFF_dmg08_cgb04c_out65766576 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopEFFF_dmg08_cgb04c_out65766576 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypopEFFF_dmg08_cgb04c_out65766576 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFDFF_dmg08_cgb04c_out657665FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFDFF_dmg08_cgb04c_out657665FF on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFE9F_dmg08_cgb04c_out6576FFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFE9F_dmg08_cgb04c_out6576FFFF on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFEFF_dmg08_cgb04c_out6576FFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFEFF_dmg08_cgb04c_out6576FFEF on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypopFFFF_dmg08_out65765576_cgb04c_out657655AA on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypush0001_dmg08_out4576AA34_cgb04c_out6576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypush8001_dmg08_out65221255_cgb04c_out65761255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypush8001_dmg08_out65221255_cgb04c_out65761255 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out6576AAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out6576AAFF on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushA001_dmg08_out4576AA34_cgb04c_out6576AA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushA001_dmg08_out4576AA34_cgb04c_out6576AA55 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushC001_2_dmg08_out4522FF34_cgb04c_out6576FF34 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushC001_dmg08_out45221234_cgb04c_out6576AA34 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushE001_dmg08_out45221234_cgb04c_out65761234 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushE001_dmg08_out45221234_cgb04c_out65761234 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushF001_dmg08_out45221234_cgb04c_out65761234 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushF001_dmg08_out45221234_cgb04c_out65761234 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushFE01_dmg08_out65221298_cgb04c_out65761298 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushFE01_dmg08_out65221298_cgb04c_out65761298 on DMG in GBHawk",
				"oamdma.oamdma_srcDF00_busypushFEA1_dmg08_out65768700_cgb04c_out65768734 on CGB_C in GBHawk",
				"oamdma.oamdma_srcDF00_busypushFF01_dmg08_out657600DF_cgb04c_out657612DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcE000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcE000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcE000_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcE000_readFE00_dmg08_out2_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcEF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcEF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcEF00_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcEF00_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcF000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcF000_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busyread0000_1_dmg08_out9_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busyread0000_1_dmg08_out9_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busyread8000_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_srcF000_busyread8000_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.oamdma_srcF000_busyreadA000_dmg08_out6_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFD00_readFE00_dmg08_out2_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcFE00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFE00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busyread0000_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busyread0000_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busyread8000_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busyread8000_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_busyreadA000_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_busyreadA000_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_readFE00_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFE00_readFE00_dmg08_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFE00_readFE00_dmg08_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_srcFE00_readFE00_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypop7FFF_dmg08_out657665AA_cgb04c_outFFFFFFAA on DMG in GBHawk", // Nintendo logo with dots
				"oamdma.oamdma_srcFF00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypop9FFF_2_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypop9FFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypopBFFF_2_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypopBFFF_dmg08_out65766576_cgb04c_outFFFFFFAA on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopDFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopEFFF_dmg08_out65766576_cgb04c_outFFFF55AA on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopFDFF_dmg08_out657665FF_cgb04c_outFFFF55FF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopFE9F_dmg08_out6576FFFF_cgb04c_outFFFFFFFF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopFEFF_dmg08_out6576FFEF_cgb04c_outFFFFFFEF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopFF7F_dmg08_out6576FFAA_cgb04c_outFFFFFFAA on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypopFFFF_dmg08_out65765576_cgb04c_outFFFF55FF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypush0001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypush8001_dmg08_out65221255_cgb04c_outFFAA1255 on DMG in GBHawk", // Nintendo logo with dots
				"oamdma.oamdma_srcFF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushA001_2_dmg08_out4576AAFF_cgb04c_out55FFAAFF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushA001_dmg08_out4576AA34_cgb04c_out55FFAA34 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushC001_2_dmg08_out4522FF34_cgb04c_outFFAAFF55 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushC001_dmg08_out45221234_cgb04c_outFFAA1255 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushE001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushF001_dmg08_out45221234_cgb04c_outFFFFAA55 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy",
				"oamdma.oamdma_srcFF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busypushFE01_dmg08_out65221298_cgb04c_outFFFFAAFF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushFEA1_dmg08_out65768700_cgb04c_outFFFFFF34 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushFF01_dmg08_out657600DF_cgb04c_outFFFF12DF on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on CGB_C in GBHawk", // completely blank
				"oamdma.oamdma_srcFF00_busypushFF81_dmg08_out6576FF55_cgb04c_outFFFFFF55 on DMG in GBHawk", // stuck on Nintendo logo
				"oamdma.oamdma_srcFF00_busyread0000_dmg08_out1_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFF00_busyread0000_dmg08_out1_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFF00_busyread0000_dmg08_out1_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_srcFF00_busyread0000_dmg08_out1_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_busyread8000_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFF00_busyread8000_dmg08_cgb04c_out3 on DMG in GBHawk",
				"oamdma.oamdma_srcFF00_busyreadA000_dmg08_out1_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFF00_busyreadA000_dmg08_out1_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFF00_busyreadA000_dmg08_out1_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_srcFF00_busyreadA000_dmg08_out1_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_readFE00_dmg08_out1_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFF00_readFE00_dmg08_out1_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFF00_readFE00_dmg08_out1_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_srcFF00_readFE00_dmg08_out1_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdma_srcFF00_readFE45_dmg08_out1_cgb04c_out0 on CGB_C in GBHawk",
				"oamdma.oamdma_srcFF00_readFE45_dmg08_out1_cgb04c_out0 on DMG in GBHawk",
				"oamdma.oamdma_srcFF00_readFE45_dmg08_out1_cgb04c_out0 on DMG in SameBoy",
				"oamdma.oamdma_srcFF00_readFE45_dmg08_out1_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdmasrc80_halt_lycirq_read8000_dmg08_cgb04c_out81 on CGB_C in SameBoy",
				"oamdma.oamdmasrc80_halt_lycirq_read8000_dmg08_cgb04c_out81 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdmasrc80_halt_lycirq_read8000_dmg08_cgb04c_out81 on DMG in GBHawk",
				"oamdma.oamdmasrc80_halt_lycirq_read8000_dmg08_cgb04c_out81 on DMG in SameBoy",
				"oamdma.oamdmasrc80_halt_lycirq_read8000_dmg08_cgb04c_out81 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdmasrc80_halt_m2irq_read8000_dmg08_cgb04c_out81 on CGB_C in SameBoy",
				"oamdma.oamdmasrc80_halt_m2irq_read8000_dmg08_cgb04c_out81 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdmasrc80_halt_m2irq_read8000_dmg08_cgb04c_out81 on DMG in GBHawk",
				"oamdma.oamdmasrc80_halt_m2irq_read8000_dmg08_cgb04c_out81 on DMG in SameBoy",
				"oamdma.oamdmasrc80_halt_m2irq_read8000_dmg08_cgb04c_out81 on DMG in SameBoy (no BIOS)",
				"oamdma.oamdmasrcC0_speedchange_readC000_cgb04c_out11 on CGB_C in SameBoy",
				"oamdma.oamdmasrcC0_speedchange_readC000_cgb04c_out11 on CGB_C in SameBoy (no BIOS)",
				"oamdma.oamdmasrcC000_hdmasrc0000_cgb04c_out0A940C0D on CGB_C in GBHawk",
				"oamdma.oamdmasrcC000_hdmasrc0000_cgb04c_out0A940C0D on CGB_C in SameBoy",
				"oamdma.oamdmasrcC000_hdmasrc0000_cgb04c_out0A940C0D on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on DMG in SameBoy",
				"scx_during_m3.scx_m3_extend_1_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_m3_extend_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"scx_during_m3.scx_m3_extend_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"scx_during_m3.scx_m3_extend_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"serial.div_write_start_wait_read_if_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.div_write_start_wait_read_if_1_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"serial.div_write_start_wait_read_if_2_dmg08_cgb04c_outE8 on DMG in SameBoy",
				"serial.nopx1_div_write_start_wait_read_if_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.nopx1_div_write_start_wait_read_if_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.nopx1_div_write_start_wait_read_if_1_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"serial.nopx1_div_write_start_wait_read_if_2_dmg08_cgb04c_outE8 on DMG in SameBoy",
				"serial.nopx1_start83_wait_read_if_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.nopx1_start83_wait_read_if_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on CGB_C in GBHawk",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on DMG in GBHawk",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on DMG in SameBoy",
				"serial.start_late_div_write_wait_read_if_1a_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_2a_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start_late_div_write_wait_read_if_2b_dmg08_cgb04c_outE8 on CGB_C in GBHawk",
				"serial.start_late_div_write_wait_read_if_2b_dmg08_cgb04c_outE8 on CGB_C in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_2b_dmg08_cgb04c_outE8 on DMG in GBHawk",
				"serial.start_late_div_write_wait_read_if_2b_dmg08_cgb04c_outE8 on DMG in SameBoy",
				"serial.start_late_div_write_wait_read_if_2b_dmg08_cgb04c_outE8 on DMG in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on CGB_C in GBHawk",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on DMG in GBHawk",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on DMG in SameBoy",
				"serial.start_late_div_write_wait_read_if_3a_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_4_dmg08_cgb04c_outE8 on CGB_C in GBHawk",
				"serial.start_late_div_write_wait_read_if_4_dmg08_cgb04c_outE8 on CGB_C in SameBoy (no BIOS)",
				"serial.start_late_div_write_wait_read_if_4_dmg08_cgb04c_outE8 on DMG in GBHawk",
				"serial.start_late_div_write_wait_read_if_4_dmg08_cgb04c_outE8 on DMG in SameBoy",
				"serial.start_late_div_write_wait_read_if_4_dmg08_cgb04c_outE8 on DMG in SameBoy (no BIOS)",
				"serial.start_wait_read_if_ds_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start_wait_read_if_ds_2_cgb04c_outE8 on CGB_C in SameBoy (no BIOS)",
				"serial.start_wait_restart_read_if_2_dmg08_cgb04c_outE8 on CGB_C in GBHawk",
				"serial.start_wait_restart_read_if_2_dmg08_cgb04c_outE8 on DMG in GBHawk",
				"serial.start_wait_trigger_int8_read_if_2_dmg08_outE8_cgb04c_outE0 on CGB_C in GBHawk",
				"serial.start_wait_trigger_int8_read_if_2_dmg08_outE8_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start_wait_trigger_int8_read_if_2_dmg08_outE8_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start_wait_trigger_int8_read_if_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start_wait_trigger_int8_read_if_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start83_late_div_write_wait_read_if_1a_cgb04c_outE0 on CGB_C in SameBoy",
				"serial.start83_late_div_write_wait_read_if_1a_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start83_late_div_write_wait_read_if_2a_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"serial.start83_late_div_write_wait_read_if_2b_cgb04c_outE8 on CGB_C in GBHawk",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_1_dmg08_cgb04c_out1 on DMG in GBHawk",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_2_dmg08_out0_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_3_dmg08_out0_cgb04c_out1 on CGB_C in GBHawk",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_3_dmg08_out0_cgb04c_out1 on DMG in SameBoy (no BIOS)",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_4_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sound.ch1_init_reset_sweep_counter_timing_nr52_4_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"sound.ch2_init_reset_length_counter_timing_nr52_1_dmg08_out2_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"sound.ch2_init_reset_length_counter_timing_nr52_4_dmg08_out2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sound.ch2_late_div_write_nr52_ds_1b_cgb04c_outF0 on CGB_C in GBHawk",
				"sound.ch2_late_div_write_nr52_ds_2b_cgb04c_outF0 on CGB_C in GBHawk",
				"sound.ch2_late_reset_nr52_2b_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sound.ch2_late_reset_nr52_2b_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sound.ch2_late_reset_nr52_2b_dmg08_cgb04c_out0 on DMG in SameBoy",
				"sound.ch2_late_reset_nr52_2b_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"sound.ch2_late_reset_nr52_ds_2b_cgb04c_out0 on CGB_C in SameBoy",
				"sound.ch2_late_reset_nr52_ds_2b_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.m2int_m3stat_scx1_lcdoffds_1_cgb04c_out3 on CGB_C in SameBoy",
				"speedchange.m2int_m3stat_scx1_lcdoffds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ch2_nr52_1a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange_ch2_nr52_1a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange_ch2_nr52_1a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ch2_nr52_2a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange_ch2_nr52_2a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange_ch2_nr52_2a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nop_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nop_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx2_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx2_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx2_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx2_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx3_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx3_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx4_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx4_m3stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_nopx4_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_nopx4_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_ly44_m3_stat_2_cgb04c_outC2 on CGB_C in SameBoy",
				"speedchange.speedchange_ly44_m3_stat_2_cgb04c_outC2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima01_nop_1_cgb04c_out07 on CGB_C in SameBoy",
				"speedchange.speedchange_tima01_nop_1_cgb04c_out07 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima01_nop_2_cgb04c_out08 on CGB_C in SameBoy",
				"speedchange.speedchange_tima01_nop_2_cgb04c_out08 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima02_2a_cgb04c_out03 on CGB_C in GBHawk",
				"speedchange.speedchange_tima02_2a_cgb04c_out03 on CGB_C in SameBoy",
				"speedchange.speedchange_tima02_2a_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima02_2b_cgb04c_out04 on CGB_C in GBHawk",
				"speedchange.speedchange_tima02_2b_cgb04c_out04 on CGB_C in SameBoy",
				"speedchange.speedchange_tima02_2b_cgb04c_out04 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima03_2a_cgb04c_out01 on CGB_C in GBHawk",
				"speedchange.speedchange_tima03_2a_cgb04c_out01 on CGB_C in SameBoy",
				"speedchange.speedchange_tima03_2a_cgb04c_out01 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange_tima03_2b_cgb04c_out02 on CGB_C in GBHawk",
				"speedchange.speedchange_tima03_2b_cgb04c_out02 on CGB_C in SameBoy",
				"speedchange.speedchange_tima03_2b_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ch2_nr52_ds_1a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange2_ch2_nr52_ds_1a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange2_ch2_nr52_ds_1a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ch2_nr52_ds_2a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange2_ch2_nr52_ds_2a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange2_ch2_nr52_ds_2a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_frame1_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_frame1_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_frame1_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in GBHawk",
				"speedchange.speedchange2_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy",
				"speedchange.speedchange2_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_lcdoff2_m2int_m3stat_scx4_1_cgb04c_out3 on CGB_C in SameBoy",
				"speedchange.speedchange2_lcdoff2_m2int_m3stat_scx4_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ly44_m3_m3stat_scx3_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange2_ly44_m3_nop_m3stat_scx1_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange2_ly44_m3_nop_m3stat_scx4_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_ly44_m3_nop_m3stat_scx4_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ly44_m3_nopx2_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_ly44_m3_nopx2_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ly44_m3_nopx2_m3stat_scx3_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange2_ly44_m3_stat_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_ly44_m3_stat_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_ly44_m3_stat_4_cgb04c_outC2 on CGB_C in SameBoy",
				"speedchange.speedchange2_ly44_m3_stat_4_cgb04c_outC2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_lcdoff_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_lcdoff_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_lcdoff_nopx2_m2int_m3stat_scx2_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_ly44_m3_m3stat_scx3_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_ly44_m3_nop_m3stat_scx1_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_ly44_m3_nop_m3stat_scx4_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_ly44_m3_nop_m3stat_scx4_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in GBHawk",
				"speedchange.speedchange2_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy",
				"speedchange.speedchange2_nop_m2int_m3stat_scx1_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima01_1_cgb04c_out09 on CGB_C in SameBoy",
				"speedchange.speedchange2_tima01_1_cgb04c_out09 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima01_2_cgb04c_out0A on CGB_C in SameBoy",
				"speedchange.speedchange2_tima01_2_cgb04c_out0A on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima01_nop_1_cgb04c_out0A on CGB_C in SameBoy",
				"speedchange.speedchange2_tima01_nop_1_cgb04c_out0A on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima01_nop_2_cgb04c_out0B on CGB_C in SameBoy",
				"speedchange.speedchange2_tima01_nop_2_cgb04c_out0B on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima02_2a_cgb04c_out03 on CGB_C in GBHawk",
				"speedchange.speedchange2_tima02_2a_cgb04c_out03 on CGB_C in SameBoy",
				"speedchange.speedchange2_tima02_2a_cgb04c_out03 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima02_2b_cgb04c_out04 on CGB_C in GBHawk",
				"speedchange.speedchange2_tima02_2b_cgb04c_out04 on CGB_C in SameBoy",
				"speedchange.speedchange2_tima02_2b_cgb04c_out04 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima03_2a_cgb04c_out01 on CGB_C in GBHawk",
				"speedchange.speedchange2_tima03_2a_cgb04c_out01 on CGB_C in SameBoy",
				"speedchange.speedchange2_tima03_2a_cgb04c_out01 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange2_tima03_2b_cgb04c_out02 on CGB_C in GBHawk",
				"speedchange.speedchange2_tima03_2b_cgb04c_out02 on CGB_C in SameBoy",
				"speedchange.speedchange2_tima03_2b_cgb04c_out02 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange3_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_ly44_m3_nop_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange3_ly44_m3_nop_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_ly44_m3_nop_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange3_nop_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange3_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange3_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange4_ch2_nr52_1a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange4_ch2_nr52_1b_cgb04c_outF0 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange4_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange4_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx3_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx3_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx3_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx4_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx4_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_ly44_m3_nop_m3stat_scx4_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in SameBoy",
				"speedchange.speedchange4_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ch2_nr52_1a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange5_ch2_nr52_1a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange5_ch2_nr52_1a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ch2_nr52_1b_cgb04c_outF0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ch2_nr52_2a_cgb04c_outF2 on CGB_C in GBHawk",
				"speedchange.speedchange5_ch2_nr52_2a_cgb04c_outF2 on CGB_C in SameBoy",
				"speedchange.speedchange5_ch2_nr52_2a_cgb04c_outF2 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ch2_nr52_2b_cgb04c_outF0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx1_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx1_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx2_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_ly44_m3_nop_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx1_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx1_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in GBHawk",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx2_1_cgb04c_outC3 on CGB_C in SameBoy (no BIOS)",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy",
				"speedchange.speedchange5_nop_ly44_m3_m3stat_scx2_2_cgb04c_outC0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_10xposA6_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_10xposA6_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy",
				"sprites.10spritesPrLine_10xposA7_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_10xposA7_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_10xposA7_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_1xpos0_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_1xpos0_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesprline_1xposa0_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesprline_1xposa0_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesprline_1xposa2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesprline_1xposa2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesprline_1xposa4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesprline_1xposa4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_1xposA8_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_1xposA8_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesprline_2xposa7overlap8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesprline_2xposa7overlap8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesprline_3overlap8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesprline_3overlap8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.10spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.10spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_offset7_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_offset7_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_xpos01_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_xpos01_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_xpos01_scx4_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_xpos01_scx4_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_xpos07_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_xpos07_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.1spritesPrLine_xpos09_scx4_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.1spritesPrLine_xpos09_scx4_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.2spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.2spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.2spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.2spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.3spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.3spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.4spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.4spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.5spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.5spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.6spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.6spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.6spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.6spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.7spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.7spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.8spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.8spritesPrLine_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.9spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.9spritesPrLine_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.enable.late_disable_ds_4_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.enable.late_disable_ds_4_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_disable_1_dmg08_out0 on DMG in GBHawk",
				"sprites.late_sizechange_2_dmg08_out0_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_3_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_3_dmg08_cgb04c_out3 on DMG in GBHawk",
				"sprites.late_sizechange_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.late_sizechange_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp00_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp00_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"sprites.late_sizechange_sp00_4_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp00_4_dmg08_cgb04c_out0 on DMG in GBHawk",
				"sprites.late_sizechange_sp00_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.late_sizechange_sp00_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange_sp00_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp01_2_dmg08_out0_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp01_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy",
				"sprites.late_sizechange_sp01_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange_sp01_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.late_sizechange_sp01_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange_sp01_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp02_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp02_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"sprites.late_sizechange_sp39_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp39_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"sprites.late_sizechange_sp39_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy",
				"sprites.late_sizechange_sp39_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange_sp39_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"sprites.late_sizechange_sp39_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange_sp39_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.late_sizechange_sp39_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange2_sp00_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp00_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"sprites.late_sizechange2_sp00_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"sprites.late_sizechange2_sp00_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange2_sp00_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp01_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"sprites.late_sizechange2_sp01_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"sprites.late_sizechange2_sp01_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp02_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp02_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"sprites.late_sizechange2_sp39_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp39_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"sprites.late_sizechange2_sp39_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"sprites.late_sizechange2_sp39_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"sprites.late_sizechange2_sp39_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"sprites.mix_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.mix_m3stat_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.mix_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.mix_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_late_scx4_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"sprites.space.10spritesPrLine_late_scx4_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_late_scx4_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr10space10_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr10space10_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr10space12_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr10space12_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr10space2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr10space2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr10space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr10space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr10space8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr10space8_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_nr1space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_nr1space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_scx4_nr1space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_scx4_nr1space4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx0_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx0_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx1_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx1_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.10spritesPrLine_wx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.10spritesPrLine_wx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.1pos8_8pos9_wx08_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.1pos8_8pos9_wx08_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.2overlap2_offset4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.2overlap2_offset4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.2overlap4_offset4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.2overlap4_offset4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap1_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap1_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap2_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap2_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap2_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap2_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap3_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap3_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap3_scx3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap3_scx3_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap3_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap3_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap3_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap3_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap4_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap4_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap4_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap4_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap5_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap5_scx2_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap5_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap5_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap5_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap5_scx5_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap5_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap5_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap5_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap5_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap6_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap6_scx4_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap7_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap7_scx7_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.space.3overlap8_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy",
				"sprites.space.3overlap8_scx6_m3stat_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"sprites.sprite_late_disable_spx18_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_disable_spx19_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_disable_spx1A_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_disable_spx1A_1_dmg08_out0 on DMG in SameBoy",
				"sprites.sprite_late_disable_spx1A_1_dmg08_out0 on DMG in SameBoy (no BIOS)",
				"sprites.sprite_late_disable_spx1B_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_enable_spx18_2_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_enable_spx1A_2_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_enable_spx1B_2_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_late_disable_spx18_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_late_disable_spx19_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_late_disable_spx1A_1_dmg08_out0 on DMG in GBHawk",
				"sprites.sprite_late_late_disable_spx1A_1_dmg08_out0 on DMG in SameBoy",
				"sprites.sprite_late_late_disable_spx1A_1_dmg08_out0 on DMG in SameBoy (no BIOS)",
				"sprites.sprite_late_late_disable_spx1B_1_dmg08_out0 on DMG in GBHawk",
				"tima.tc00_irq_ds_1_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"tima.tc00_irq_ds_2_cgb04c_outE4 on CGB_C in SameBoy (no BIOS)",
				"tima.tc00_irq_late_retrigger_2_dmg08_outE4_cgb04c_outE0 on CGB_C in GBHawk",
				"tima.tc00_irq_late_retrigger_2_dmg08_outE4_cgb04c_outE0 on CGB_C in SameBoy",
				"tima.tc00_irq_late_retrigger_2_dmg08_outE4_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"tima.tc00_irq_late_retrigger_ds_2_cgb04c_outE0 on CGB_C in SameBoy",
				"tima.tc00_irq_late_retrigger_ds_2_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"tima.tc00_start_2_cgb04c_outF1 on CGB_C in SameBoy (no BIOS)",
				"tima.tc00_start_3_dmg08_outF0 on DMG in SameBoy (no BIOS)",
				"tima.tc01_late_tima_irq_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy",
				"tima.tc01_late_tima_irq_1_dmg08_cgb04c_outE0 on CGB_C in SameBoy (no BIOS)",
				"tima.tc01_late_tima_irq_1_dmg08_cgb04c_outE0 on DMG in SameBoy",
				"tima.tc01_late_tima_irq_1_dmg08_cgb04c_outE0 on DMG in SameBoy (no BIOS)",
				"vram_m3.10spritesprline_postread_2_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"vram_m3.10spritesprline_postread_2_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.postread_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"vram_m3.postread_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.postread_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.postread_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"vram_m3.postread_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.preread_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"vram_m3.preread_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.preread_lcdoffset2_1_cgb04c_out0 on CGB_C in GBHawk",
				"vram_m3.preread_lcdoffset2_1_cgb04c_out0 on CGB_C in SameBoy",
				"vram_m3.preread_lcdoffset2_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.preread_lcdoffset2_2_cgb04c_out3 on CGB_C in SameBoy",
				"vram_m3.prewrite_ds_1_cgb04c_out1 on CGB_C in GBHawk",
				"vram_m3.prewrite_ds_1_cgb04c_out1 on CGB_C in SameBoy",
				"vram_m3.prewrite_ds_2_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.prewrite_lcdoffset2_1_cgb04c_out1 on CGB_C in GBHawk",
				"vram_m3.prewrite_lcdoffset2_1_cgb04c_out1 on CGB_C in SameBoy",
				"vram_m3.prewrite_lcdoffset2_1_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"vram_m3.prewrite_lcdoffset2_2_cgb04c_out0 on CGB_C in SameBoy",
				"vram_m3.vramw_m3start_1_dmg08_cgb04c_out1 on CGB_C in SameBoy",
				"vram_m3.vramw_m3start_1_dmg08_cgb04c_out1 on CGB_C in SameBoy (no BIOS)",
				"vramw_m3end.vramw_m3end_2_dmg08_cgb04c_out7 on CGB_C in SameBoy",
				"vramw_m3end.vramw_m3end_2_dmg08_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"vramw_m3end.vramw_m3end_4_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"vramw_m3end.vramw_m3end_4_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"vramw_m3end.vramw_m3end_ds_5_cgb04c_out1 on CGB_C in GBHawk",
				"vramw_m3end.vramw_m3end_scx3_5_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"vramw_m3end.vramw_m3end_scx3_5_dmg08_cgb04c_out3 on DMG in GBHawk",
				"vramw_m3end.vramw_m3end_scx5_ds_2_cgb04c_out7 on CGB_C in SameBoy",
				"vramw_m3end.vramw_m3end_scx5_ds_2_cgb04c_out7 on CGB_C in SameBoy (no BIOS)",
				"vramw_m3end.vramw_m3end_scx5_ds_4_cgb04c_out0 on CGB_C in SameBoy",
				"vramw_m3end.vramw_m3end_scx5_ds_4_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_enable_afterVblank_4_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.arg.late_enable_afterVblank_4_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_enable_afterVblank_4_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_enable_afterVblank_4_dmg08_out3_cgb04c_out0 on DMG in SameBoy",
				"window.arg.late_enable_afterVblank_4_dmg08_out3_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.arg.late_enable_afterVblank_5_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.arg.late_enable_afterVblank_5_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx00_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx00_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx00_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx00_2_dmg08_out3_cgb04c_out0 on DMG in SameBoy",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx00_2_dmg08_out3_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_3_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_scx_late_wy_FFto4_ly4_wx20_3_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wx_late_wy_FFto2_ly2_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wx_late_wy_FFto2_ly2_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_10to0_ly1_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_10to0_ly1_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_10to0_ly1_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_10to1_ly1_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_10to1_ly1_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_10to1_ly1_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_10to1_ly1_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_10to1_ly1_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_1toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_1toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_1toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on DMG in SameBoy",
				"window.arg.late_wy_1toFF_3_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.arg.late_wy_1toFF_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_1toFF_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_1toFF_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_1toFF_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_1toFF_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_1toFF_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_1toFF_lcdoffset1_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_1toFF_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_1toFF_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"window.arg.late_wy_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.arg.late_wy_2toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_2toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_2toFF_2_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on DMG in SameBoy",
				"window.arg.late_wy_2toFF_3_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto0_ly0_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto0_ly0_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto0_ly0_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto0_ly0_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto0_ly0_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto0_ly2_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto0_ly2_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto0_ly2_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto0_ly2_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto0_ly2_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto0_ly2_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto1_ly2_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto1_ly2_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto1_ly2_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx2_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx2_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx2_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_scx2_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx2_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx2_3_dmg08_cgb04c_out0 on DMG in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx2_3_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_scx3_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx3_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx3_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx3_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_scx3_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx3_3_dmg08_cgb04c_out0 on DMG in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx3_3_dmg08_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_scx5_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx5_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx5_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx5_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_scx5_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx5_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_wx00_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_wx00_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_wx00_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_wx00_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_wx00_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_wx0f_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.arg.late_wy_FFto2_ly2_wx0f_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.arg.late_wy_FFto2_ly2_wx0f_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.arg.late_wy_FFto2_ly2_wx0f_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.arg.late_wy_FFto2_ly2_wx0f_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_0_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_0_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx00_wx11_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx00_wx11_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx00_wx11_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx00_wx12_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx00_wx12_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx00_wx12_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx03_wx0f_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_early_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_early_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_early_scx03_wx10_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_early_scx03_wx11_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx03_wx11_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_early_scx03_wx12_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_early_scx03_wx12_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_early_scx03_wx12_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.late_disable_late_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx00_wx0f_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx00_wx10_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx0f_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_late_scx03_wx0f_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx0f_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx0f_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx10_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx10_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_late_scx03_wx10_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx10_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx10_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx11_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx11_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_late_scx03_wx11_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx11_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx11_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx11_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_late_scx03_wx12_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_scx2_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx2_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_scx2_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx2_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_disable_scx2_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_scx3_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx3_0_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_scx3_0_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_scx3_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_scx3_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx3_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_scx3_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_scx5_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx5_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_scx5_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx5_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_scx5_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_scx5_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_disable_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_spx10_wx0f_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_spx10_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_spx10_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_spx10_wx0f_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_wx0f_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_wx0f_0_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_wx0f_0_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_disable_wx0f_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_disable_wx0f_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_disable_wx0f_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_disable_wx0f_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_enable_afterVblank_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_enable_afterVblank_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_enable_afterVblank_2_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_enable_afterVblank_2_dmg08_out3_cgb04c_out0 on DMG in SameBoy",
				"window.late_enable_afterVblank_2_dmg08_out3_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.late_enable_afterVblank_3_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_enable_afterVblank_3_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_enable_afterVblank_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_enable_afterVblank_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_enable_afterVblank_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_enable_afterVblank_ds_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_enable_afterVblank_lcdoffset1_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_enable_afterVblank_lcdoffset1_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_enable_afterVblank_lcdoffset1_2_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_enable_ly0_ds_1_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_enable_ly0_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_enable_ly0_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_reenable_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_reenable_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_reenable_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_scx2_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_reenable_scx2_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_reenable_scx2_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_reenable_scx2_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_reenable_scx2_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.late_reenable_scx2_3_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_scx2_3_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_reenable_scx3_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_reenable_scx3_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_reenable_scx3_2_dmg08_out3_cgb04c_out0 on DMG in GBHawk",
				"window.late_reenable_scx3_3_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_scx3_3_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_reenable_scx5_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_reenable_scx5_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_reenable_scx5_2_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_scx5_3_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_scx5_3_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_reenable_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_reenable_scx5_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_reenable_scx5_ds_2_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_wx0f_2_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_reenable_wx0f_2_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_scx_late_disable_0_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_scx_late_disable_0_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_scx_late_disable_0_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_scx_late_disable_0_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_scx_late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_scx_late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_scx_late_disable_1_dmg08_out3_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_wx_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wx_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_ds_1_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_wx_ds_1_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_ff_07_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wx_ff_07_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_wx_ff_0f_1_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wx_ff_0f_1_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_wx_scx2_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_scx2_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wx_scx2_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wx_scx2_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_scx3_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_scx3_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wx_scx3_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.late_wx_scx5_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_scx5_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wx_scx5_ds_1_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wx_scx5_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_wx03_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_wx03_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_wx_wx03_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_wx03_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wx_wx0f_1_dmg08_cgb04c_out0 on CGB_C in GBHawk",
				"window.late_wx_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy",
				"window.late_wx_wx0f_1_dmg08_cgb04c_out0 on CGB_C in SameBoy (no BIOS)",
				"window.late_wx_wx0f_1_dmg08_cgb04c_out0 on DMG in GBHawk",
				"window.late_wy_2_dmg08_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wy_2_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wy_2_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_wy_2_dmg08_cgb04c_out3 on DMG in GBHawk",
				"window.late_wy_2_dmg08_cgb04c_out3 on DMG in SameBoy",
				"window.late_wy_2_dmg08_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.late_wy_ds_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wy_ds_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wy_ds_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_wy_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wy_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wy_ds_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.late_wy_lcdoffset1_2_cgb04c_out3 on CGB_C in GBHawk",
				"window.late_wy_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy",
				"window.late_wy_lcdoffset1_2_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wx03_scx2_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wx03_scx2_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wx03_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wx03_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wx07_scx2_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wx07_scx2_m3stat_1_dmg08_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wx07_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wx07_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_firstline_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy",
				"window.m2int_wxA6_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on DMG in SameBoy",
				"window.m2int_wxA6_m0irq2_2_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_oambusyread_2_dmg08_out5_cgb04c_out0 on DMG in GBHawk",
				"window.m2int_wxA6_oambusyread_2_dmg08_out5_cgb04c_out0 on DMG in SameBoy",
				"window.m2int_wxA6_oambusyread_2_dmg08_out5_cgb04c_out0 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx2_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_scx2_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_scx2_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx2_m3stat_3_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wxA6_scx2_m3stat_3_dmg08_out0_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx2_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_scx2_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_scx2_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx3_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_scx3_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_scx3_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx3_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_scx3_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_scx3_m3stat_3_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx5_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_scx5_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_scx5_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy",
				"window.m2int_wxA6_scx5_m3stat_ds_1_cgb04c_out3 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in GBHawk",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on CGB_C in SameBoy (no BIOS)",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on DMG in GBHawk",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy",
				"window.m2int_wxA6_spxA7_m0irq_2_dmg08_cgb04c_out2 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_spxA7_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_spxA7_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy",
				"window.m2int_wxA6_spxA7_m3stat_2_dmg08_out0_cgb04c_out3 on DMG in SameBoy (no BIOS)",
				"window.m2int_wxA6_spxA7_m3stat_4_dmg08_out0_cgb04c_out3 on DMG in GBHawk",
				"window.m2int_wxA6_vrambusyread_2_dmg08_out5_cgb04c_out0 on DMG in GBHawk",
				"window.m2int_wxA6_vrambusyread_2_dmg08_out5_cgb04c_out0 on DMG in SameBoy",
				"window.m2int_wxA6_vrambusyread_2_dmg08_out5_cgb04c_out0 on DMG in SameBoy (no BIOS)",
			};

			public readonly string ExpectedValue;

			public readonly string RomEmbedPath;

			public readonly CoreSetup Setup;

			public readonly string TestName;

			public GambatteHexStrTestCase(string testName, CoreSetup setup, string romEmbedPath, string expectedValue)
			{
				TestName = testName;
				Setup = setup;
				RomEmbedPath = romEmbedPath;
				ExpectedValue = expectedValue;
			}

			public readonly string DisplayName()
				=> $"{TestName} on {Setup}";
		}

		public readonly struct GambatteRefImageTestCase
		{
			public static readonly GambatteRefImageTestCase Dummy = new("missing_files", new(CoreNames.Gambatte, ConsoleVariant.DMG), string.Empty, string.Empty);

			public static readonly IReadOnlyList<string> KnownFailures = new[]
			{
				"bgen.bgoff_bgon_sprite_below_window on CGB_C in SameBoy",
				"bgen.bgoff_bgon_sprite_below_window on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx08_1 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx08_1 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx08_1 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx08_2 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx08_3 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx08_3 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx08_3 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx08_4 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx08_ds_3 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx08_ds_3 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx08_ds_4 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx08_ds_4 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx09_ds_1 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx09_ds_1 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx09_ds_3 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx09_ds_3 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx09_ds_4 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx09_ds_4 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx0A_1 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx0A_1 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx0A_1 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx0A_2 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx0A_3 on CGB_C in SameBoy",
				"bgtiledata.bgtiledata_spx0A_3 on CGB_C in SameBoy (no BIOS)",
				"bgtiledata.bgtiledata_spx0A_3 on DMG in GBHawk",
				"bgtiledata.bgtiledata_spx0A_4 on DMG in GBHawk",
				"bgtilemap.bgtilemap_spx08_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx08_2 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_2 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx08_3 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_3 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx08_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_4 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx08_ds_1 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx08_ds_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_ds_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx08_ds_2 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx08_ds_3 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx08_ds_4 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx08_ds_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx08_ds_4 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_1 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx09_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_2 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx09_2 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_2 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_3 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx09_3 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_3 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_4 on CGB_C in GBHawk",
				"bgtilemap.bgtilemap_spx09_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_4 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_ds_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_ds_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx09_ds_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx09_ds_4 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0A_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0A_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0A_1 on DMG in GBHawk",
				"bgtilemap.bgtilemap_spx0A_2 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0A_2 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0A_2 on DMG in GBHawk",
				"bgtilemap.bgtilemap_spx0A_3 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0A_3 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0A_3 on DMG in GBHawk",
				"bgtilemap.bgtilemap_spx0A_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0A_4 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0A_4 on DMG in GBHawk",
				"bgtilemap.bgtilemap_spx0B_1 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0B_1 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0B_2 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0B_2 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0B_3 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0B_3 on CGB_C in SameBoy (no BIOS)",
				"bgtilemap.bgtilemap_spx0B_4 on CGB_C in SameBoy",
				"bgtilemap.bgtilemap_spx0B_4 on CGB_C in SameBoy (no BIOS)",
				"dmgpalette_during_m3.dmgpalette_during_m3_2 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_3 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_3 on DMG in SameBoy",
				"dmgpalette_during_m3.dmgpalette_during_m3_3 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.dmgpalette_during_m3_4 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_4 on DMG in SameBoy",
				"dmgpalette_during_m3.dmgpalette_during_m3_4 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.dmgpalette_during_m3_5 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_5 on DMG in SameBoy",
				"dmgpalette_during_m3.dmgpalette_during_m3_5 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx1_4 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx1_4 on DMG in SameBoy",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx1_4 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx2_1 on DMG in GBHawk",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx2_1 on DMG in SameBoy",
				"dmgpalette_during_m3.dmgpalette_during_m3_scx2_1 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_1 on DMG in GBHawk",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_2 on DMG in GBHawk",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_3 on DMG in GBHawk",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_3 on DMG in SameBoy",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_3 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_4 on DMG in GBHawk",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_4 on DMG in SameBoy",
				"dmgpalette_during_m3.lycint_dmgpalette_during_m3_4 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_1 on DMG in GBHawk",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_2 on DMG in GBHawk",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_3 on DMG in GBHawk",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_4 on DMG in GBHawk",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_4 on DMG in SameBoy",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_4 on DMG in SameBoy (no BIOS)",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_5 on DMG in GBHawk",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_5 on DMG in SameBoy",
				"dmgpalette_during_m3.scx3.dmgpalette_during_m3_5 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0060c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_1 on DMG in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_2 on DMG in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0063c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on DMG in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on DMG in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_2 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on DMG in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on DMG in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_3 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_4 on DMG in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_5 on DMG in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_6 on DMG in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_7 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_8 on CGB_C in GBHawk",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0360c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_1 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_2 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_3 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_4 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_5 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_6 on DMG in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_7 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_8 on CGB_C in GBHawk",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0363c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_1 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on DMG in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_2 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on DMG in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_3 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_4 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_5 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_6 on DMG in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_7 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_8 on CGB_C in GBHawk",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0367c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on DMG in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on DMG in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_2 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on DMG in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on DMG in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_3 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on DMG in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on DMG in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_4 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_5 on DMG in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_6 on DMG in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_1 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_1 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_2 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_2 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_3 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_3 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_4 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_4 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_5 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_5 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_6 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_6 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_7 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_7 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_8 on CGB_C in GBHawk",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_8 on CGB_C in SameBoy",
				"scx_during_m3.scx_0761c0.scx_during_m3_ds_8 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_attrib_during_m3_spx1_ds on CGB_C in GBHawk",
				"scx_during_m3.scx_attrib_during_m3_spx1_ds on CGB_C in SameBoy",
				"scx_during_m3.scx_attrib_during_m3_spx1_ds on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_attrib_during_m3_spx2_ds on CGB_C in GBHawk",
				"scx_during_m3.scx_attrib_during_m3_spx2_ds on CGB_C in SameBoy",
				"scx_during_m3.scx_attrib_during_m3_spx2_ds on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_during_m3_spx0 on CGB_C in GBHawk",
				"scx_during_m3.scx_during_m3_spx0 on CGB_C in SameBoy",
				"scx_during_m3.scx_during_m3_spx0 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_during_m3_spx0 on DMG in GBHawk",
				"scx_during_m3.scx_during_m3_spx1 on CGB_C in GBHawk",
				"scx_during_m3.scx_during_m3_spx1 on DMG in GBHawk",
				"scx_during_m3.scx_during_m3_spx2 on CGB_C in GBHawk",
				"scx_during_m3.scx_during_m3_spx2 on CGB_C in SameBoy",
				"scx_during_m3.scx_during_m3_spx2 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx_during_m3_spx2 on DMG in GBHawk",
				"scx_during_m3.scx_during_m3_spx2_ds on CGB_C in GBHawk",
				"scx_during_m3.scx_during_m3_spx2_ds on CGB_C in SameBoy",
				"scx_during_m3.scx_during_m3_spx2_ds on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx1_scx0_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx1_scx0_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx1_scx0_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx2_scx0_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx2_scx0_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx2_scx0_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scx_during_m3.scx2_scx0_during_m3_1 on DMG in GBHawk",
				"scx_during_m3.scx2_scx0_during_m3_1 on DMG in SameBoy",
				"scx_during_m3.scx2_scx0_during_m3_1 on DMG in SameBoy (no BIOS)",
				"scx_during_m3.scx2_scx1_during_m3_1 on CGB_C in GBHawk",
				"scx_during_m3.scx2_scx1_during_m3_1 on CGB_C in SameBoy",
				"scx_during_m3.scx2_scx1_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_1 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_2 on CGB_C in GBHawk",
				"scy.scx3.scy_during_m3_2 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_3 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_4 on CGB_C in GBHawk",
				"scy.scx3.scy_during_m3_4 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_5 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_5 on CGB_C in SameBoy (no BIOS)",
				"scy.scx3.scy_during_m3_6 on CGB_C in GBHawk",
				"scy.scx3.scy_during_m3_6 on CGB_C in SameBoy",
				"scy.scx3.scy_during_m3_6 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_2 on CGB_C in GBHawk",
				"scy.scy_during_m3_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_4 on CGB_C in GBHawk",
				"scy.scy_during_m3_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_5 on CGB_C in SameBoy",
				"scy.scy_during_m3_5 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_6 on CGB_C in GBHawk",
				"scy.scy_during_m3_6 on CGB_C in SameBoy",
				"scy.scy_during_m3_6 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_5 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_5 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_6 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_6 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_ds_7 on CGB_C in SameBoy",
				"scy.scy_during_m3_ds_7 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_1 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_2 on DMG in GBHawk",
				"scy.scy_during_m3_spx08_3 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_ds_1 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_ds_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_ds_2 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_ds_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_ds_3 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_ds_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx08_ds_4 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx08_ds_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx08_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_1 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx09_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_2 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx09_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_3 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx09_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_4 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx09_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_ds_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_ds_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_ds_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_ds_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_ds_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_ds_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx09_ds_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx09_ds_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0A_1 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx0A_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0A_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0A_1 on DMG in GBHawk",
				"scy.scy_during_m3_spx0A_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0A_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0A_2 on DMG in GBHawk",
				"scy.scy_during_m3_spx0A_3 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx0A_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0A_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0A_3 on DMG in GBHawk",
				"scy.scy_during_m3_spx0A_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0A_4 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0B_1 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx0B_1 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0B_1 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0B_2 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0B_2 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0B_3 on CGB_C in GBHawk",
				"scy.scy_during_m3_spx0B_3 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0B_3 on CGB_C in SameBoy (no BIOS)",
				"scy.scy_during_m3_spx0B_4 on CGB_C in SameBoy",
				"scy.scy_during_m3_spx0B_4 on CGB_C in SameBoy (no BIOS)",
				"window.on_screen.weon_wx18_weoff_weon_wx80 on CGB_C in GBHawk",
				"window.on_screen.weon_wx18_weoff_weon_wx80 on CGB_C in SameBoy",
				"window.on_screen.weon_wx18_weoff_weon_wx80 on CGB_C in SameBoy (no BIOS)",
				"window.on_screen.weon_wx18_weoff_weon_wx80 on DMG in GBHawk",
				"window.on_screen.wx17_weoff_wxA5_weon on CGB_C in GBHawk",
				"window.on_screen.wx17_weoff_wxA5_weon on DMG in GBHawk",
				"window.on_screen.wxA5_weoff_at_xposA5 on CGB_C in GBHawk",
				"window.on_screen.wxA5_weoff_at_xposA5 on DMG in GBHawk",
				"window.on_screen.wxA6_3 on DMG in GBHawk",
				"window.on_screen.wxA6_3 on DMG in SameBoy",
				"window.on_screen.wxA6_3 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_late_we_reenable_1 on DMG in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_1 on DMG in SameBoy",
				"window.on_screen.wxA6_late_we_reenable_1 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_late_we_reenable_2 on CGB_C in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_2 on DMG in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_2 on DMG in SameBoy",
				"window.on_screen.wxA6_late_we_reenable_2 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_late_we_reenable_3 on CGB_C in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_3 on CGB_C in SameBoy",
				"window.on_screen.wxA6_late_we_reenable_3 on CGB_C in SameBoy (no BIOS)",
				"window.on_screen.wxA6_late_we_reenable_3 on DMG in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_3 on DMG in SameBoy",
				"window.on_screen.wxA6_late_we_reenable_3 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_late_we_reenable_4 on CGB_C in GBHawk",
				"window.on_screen.wxA6_late_we_reenable_4 on CGB_C in SameBoy",
				"window.on_screen.wxA6_late_we_reenable_4 on CGB_C in SameBoy (no BIOS)",
				"window.on_screen.wxA6_scx7 on DMG in GBHawk",
				"window.on_screen.wxA6_scx7 on DMG in SameBoy",
				"window.on_screen.wxA6_scx7 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_weoff_at_xposA6 on CGB_C in GBHawk",
				"window.on_screen.wxA6_weoff_at_xposA6 on DMG in GBHawk",
				"window.on_screen.wxA6_weoff_at_xposA6 on DMG in SameBoy",
				"window.on_screen.wxA6_weoff_at_xposA6 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_wy00 on DMG in GBHawk",
				"window.on_screen.wxA6_wy00 on DMG in SameBoy",
				"window.on_screen.wxA6_wy00 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_wy01 on DMG in GBHawk",
				"window.on_screen.wxA6_wy01 on DMG in SameBoy",
				"window.on_screen.wxA6_wy01 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_wy01_weoff_ly02 on DMG in GBHawk",
				"window.on_screen.wxA6_wy01_weoff_ly02 on DMG in SameBoy",
				"window.on_screen.wxA6_wy01_weoff_ly02 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_wy01_weoff_ly02_weon_ly60 on DMG in GBHawk",
				"window.on_screen.wxA6_wy01_weoff_ly02_weon_ly60 on DMG in SameBoy",
				"window.on_screen.wxA6_wy01_weoff_ly02_weon_ly60 on DMG in SameBoy (no BIOS)",
				"window.on_screen.wxA6_wy01_wxA5_ly02 on DMG in GBHawk",
				"window.on_screen.wxA6_wy01_wxA7_ly02 on DMG in GBHawk",
				"window.on_screen.wxA6_wy8F on DMG in GBHawk",
				"window.on_screen.wxA6_wy8F on DMG in SameBoy",
				"window.on_screen.wxA6_wy8F on DMG in SameBoy (no BIOS)",
			};

			public readonly string ExpectEmbedPath;

			public readonly string RomEmbedPath;

			public readonly CoreSetup Setup;

			public readonly string TestName;

			public GambatteRefImageTestCase(string testName, CoreSetup setup, string romEmbedPath, string expectEmbedPath)
			{
				TestName = testName;
				Setup = setup;
				RomEmbedPath = romEmbedPath;
				ExpectEmbedPath = expectEmbedPath;
			}

			public readonly string DisplayName()
				=> $"{TestName} on {Setup}";
		}
	}
}
